<?php
session_start();
##	Mike Robinson
##	2009-MAY-20
##	tool to view your MySQL database on the web
##	uses MySQL information schema for structure 
##	and a small language to allow customisation
##
## Language Syntax
##	 LOGIN user pwd db localhost				# login to your database
##
##	 SET var str						# set custom xv ie title, tables, info
##
##	 TABLE tables						# list of tables (see below) to apply commands
##		START [ PICK ]					# main table to show (PICK picks a rec at random)
##		MAIN_COL fields					# which field is the describing field
##		HIDE fields					# which fields to hide
##		SEARCH fields					# which fields to search on
##		URL fields					# fields that are images, urls, mp3s, emails etc
##		VERTICAL 					# display individual record vertically
##		EDIT ( GUEST | SPECIAL | ADMIN )		# allow updating of data
##		RENAME str
##
##	FIELD fields
##		RENAME str
##		VALUES list
##		DEFAULT str
##		FORMAT str
##		LINK table field
##		UPERCASE
##		LOWERCASE
##
##	 REPORT name [ ON field ] [ START ] "SQL select statement"	# build reports
##	
##	str := "string with spaces" | 123 | string_no_spaces
##	tables := tabA,tabB,tabC | tabA | 'tab%' | ALL
##	fields := fieldA,fieldB,fieldC | fieldA | 'field%' | ALL
##	field := fieldA
##	var := title | info | img_x_size | img_y_size | url_base_dir ...
##	
## The code below has had comments and indenting removed
$ip = $_SERVER[REMOTE_ADDR];
$err = "";
$program = "";
$logged_in = 0;
$prog="index.php";
$main_dir='/var/tmp/db2web';
$db2web_home = "http://www.checkmypages.com/db2web";
$log_dir=$main_dir . ereg_replace( '.*/','/', getcwd());
$lookup = array("BACKGROUNDS" => array(	"PAPER" => "$db2web_home/bg_paper.jpg", 
"PLANT" => "$db2web_home/bg_plant.jpg",
"ROCK" => "$db2web_home/bg_rock.gif", 
"WATER" => "$db2web_home/bg_water.gif",
"WOOD" => "$db2web_home/bg_wood.jpg" ),
"FORMAT" => array(	"NUMBER" => "^-?[0-9][0-9]*[.]?[0-9]*$", 
"DATE" => "^[0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]$",
"EMAIL" => "^[a-z0-9_.-]+@[a-z0-9_-]+\.[a-z0-9_.-]+$" ),
"VALUES" => array(	"GENDER" => array( "Male", "Female" ), 
"TITLE" => array( "Mr","Mrs","Miss","Dr" ),
"WEEKDAY" => array( "Sun","Mon","Tue","Wed","Thu","Fri","Sat" ),
"MONTH" => array( "Jan", "Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec" ),
"CONTINENT" => array( "Africa" , "Antartica", "Asia", 
"Europe", "North America", "Oceania", 
"South and Central America" ),
"CURRENCY" => array( "USD", "EURO", "POUND", "YEN" ),
"COUNTRY" => array( "AFGHANISTAN", "ALBANIA", "ALGERIA", 
"ANDORRA", "ANGOLA", "ANGUILLA", "ANTARCTICA", "ANTIGUA AND BARBUDA",
"ARGENTINA", "ARMENIA", "ARUBA", "AUSTRALIA", "AUSTRIA", 
"AZERBAIJAN", "BAHAMAS", "BAHRAIN", "BANGLADESH", "BARBADOS", 
"BELARUS", "BELGIUM", "BELIZE", "BENIN", "BERMUDA", "BOLIVIA", 
"BOSNIA AND HERZEGOVINA", "BOTSWANA", "BRAZIL", "BRUNEI", 
"BULGARIA", "BURMA", "CAMBODIA", "CAMEROON", "CANADA", 
"CENTRAL AFRICAN REPUBLIC", "CHILE", "CHINA", "COLOMBIA", 
"COSTA RICA", "CROATIA", "CUBA", "CYPRUS", "CZECH REPUBLIC", 
"DENMARK", "DOMINICA", "DOMINICAN REPUBLIC", "ECUADOR", "EGYPT", 
"ESTONIA", "ETHIOPIA", "FIJI", "FINLAND", "FRANCE", "FRENCH GUIANA", 
"FRENCH POLYNESIA", "GABON", "GAMBIA", "GEORGIA", "GERMANY", 
"GHANA", "GIBRALTAR", "GREECE", "GREENLAND", "GRENADA", "GUATEMALA", 
"GUERNSEY", "GUYANA", "HAITI", "HONDURAS", "HONG KONG", "HUNGARY", 
"ICELAND", "INDIA", "INDONESIA", "IRAN", "IRAQ", "IRELAND", 
"ISLE OF MAN", "ISRAEL", "ITALY", "JAMAICA", "JAPAN", "JERSEY", 
"JORDAN", "KAZAKHSTAN", "KENYA", "KUWAIT", "LAOS", "LATVIA", 
"LEBANON", "LIBERIA", "LIBYA", "LIECHTENSTEIN", "LITHUANIA", 
"LUXEMBOURG", "MACAO", "MACEDONIA", "MADAGASCAR", "MALAWI", 
"MALAYSIA", "MALDIVES", "MALI", "MALTA", "MARTINIQUE", 
"MAURITANIA", "MAURITIUS", "MAYOTTE", "MEXICO", "MICRONESIA", 
"MOLDOVA", "MONACO", "MONGOLIA", "MONTENEGRO", "MONTSERRAT", 
"MOROCCO", "MOZAMBIQUE", "MYANMAR", "NAMIBIA", "NAURU", "NEPAL", 
"NETHERLANDS ANTILLES", "NETHERLANDS", "NEW ZEALAND", 
"NICARAGUA", "NIGER", "NIGERIA", "NORFOLK ISLAND", "NORTH KOREA", 
"NORWAY", "OMAN", "PAKISTAN", "PALESTINIAN TERRITORY", "PANAMA", 
"PARAGUAY", "PERU", "PHILIPPINES", "POLAND", "PORTUGAL", 
"PUERTO RICO", "ROMANIA", "RUSSIA", "RWANDA", "SAMOA", 
"SAUDI ARABIA", "SENEGAL", "SERBIA AND MONTENEGRO", "SERBIA", 
"SEYCHELLES", "SINGAPORE", "SLOVAKIA", "SLOVENIA", "SOMALIA", 
"SOUTH AFRICA", "SOUTH GEORGIA", "SOUTH KOREA", "SPAIN", 
"SRI LANKA", "SUDAN", "SURINAME", "SWEDEN", "SWITZERLAND", 
"SYRIA", "TAIWAN", "TAJIKISTAN", "THAILAND", "TOGO", "TONGA", 
"TRINIDAD AND TOBAGO", "TUNISIA", "TURKEY", "TURKMENISTAN", 
"TUVALU", "U.S. VIRGIN ISLANDS", "UGANDA", "UKRAINE", 
"UNITED ARAB EMIRATES", "UNITED KINGDOM", "UNITED STATES", 
"URUGUAY", "UZBEKISTAN", "VATICAN", "VENEZUELA", "VIETNAM", 
"YEMEN", "ZAMBIA", "ZIMBABWE" ),
"YN" => array( "Yes", "No" ) ),
"VARIABLES" => array(	'col_txt', 'col_bg', 'col_tab_bg', 'col_buttons',
'max_show', 'max_all_show', 'max_groups', 'max_logs',
'tables', 'url_base_dir', 'img_bg',
'img_x_size','img_y_size','img_x_size_small','img_y_size_small',
'title','description','info','special_pwd',
'max_linked_list','max_radio_list',
'max_recent_items','borders',
'admin_ip', 'admin_email' ),
"ENCRYPT_VAR" => array( 'dbu','dbp','dbd','dbs','special_pwd' ),
"IMAGE_POSTFIXES" => array( 'jpg','gif','png','jpeg' ),
"AUDIO_POSTFIXES" => array( 'mp3','ram','ogg','wav' ),
"VIDEO_POSTFIXES" => array( 'avi','mp4','mpg','wmv','mov' ) );
$submit = get_param( "submit" );
$in_tab = get_param( "tab" );
$in_pk = get_param( "pk" );
$in_id = get_param( "id" );
$in_str = get_param( "str" );
$in_limit = get_param( "limit" );
$from = get_param( "from" );
$to = get_param( "to" );
$form = $_POST["form"];
if ( $in_limit == "" ) { $in_limit = 0; }
if ( $in_str == "Search" ) { $in_str = ""; }
if ( $in_str > "" and in_array($submit , array( "","Update","Confirm Update","Insert" ) ) ) { $submit = "Search"; }
$in_id_url = urlencode( $in_id );
$cv = array();
$msg = "";
$done_flg = 0;
$file = `ls $log_dir/program`;
if ( $file == "" ) {
$err .= " Initialised system.";
system( "mkdir $main_dir; chmod 777 $main_dir" );
system( "mkdir $log_dir; chmod 777 $log_dir" );
system( "echo '' > $log_dir/compiled" );
system( "echo '' > $log_dir/users" );
log_msg( "Initialised system" );
$program =	"# Change the login details to access your MySQL database\n" .
"LOGIN username password db_name localhost\n\n" .
"# Give your system a title\n" .
"SET title 'NameForYourSystem'\n\n" .
"# Restrict it to view certain tables\n" .
"SET tables ALL\n\n" .
"# Customise which fields are shown, searched or hidden etc\n" .
"TABLE ALL SEARCH '%name'\n" .
"         MAIN_COL '%name'\n\n" .
"# Make one table your main starting point\n" .
"TABLE YourMainTable START MAIN_COL '%name'\n";
$fh = fopen( "$log_dir/program", "w" );
fwrite( $fh, $program );
fclose( $fh );
$_SESSION["last_logged_in"] = time();
$_SESSION["user_type"] = "admin";
$submit = "Admin";
} else {
$tmp = file_get_contents( "$log_dir/compiled" );
if ( $tmp > "" ) {
$cv = unserialize( $tmp );
} else {
$program = compile_twice();
}
encrypt_var( 'decode' );
try_logging_in( );
}
if ( ! isset( $_SESSION["user_type"] ) ) { $_SESSION["user_type"] = "guest"; }
if ( ! isset( $_SESSION["special_pwd"] ) ) { $_SESSION["special_pwd"] = ""; }
if ( ! isset( $_SESSION["recent_items"] ) ) { $_SESSION["recent_items"] = array(); }
if ( ! isset( $_SESSION["mobile"] ) ) { $_SESSION["mobile"] = mobile_device_detect( ); }
if ( $submit == "Search" ) {
if ( ! ereg( '...',$in_str ) ) {
$err = " Search must be at least 3 chars.";
$submit = "";
}
if ( $cv[ 'SQL_SEARCH' ] == "" ) {
$err = " No tables and fields have been set up for searching.";
$submit = "";
}
}
if ( $submit == "Mobile" ) {
$_SESSION["mobile"] = ! $_SESSION["mobile"];
$submit = "";
}
$mobile_flg = $_SESSION["mobile"];
if ( 	$in_tab == "" and $in_pk == "" 
and in_array( $submit,array( "","Home" ) )
and ereg( "^REPORT:", $cv["START"] ) ) {
$submit="Report";
$in_str = ereg_replace( "^REPORT:", "", $cv["START"] );
}
if ( $submit == "Search" and $in_str > "" and $in_str == $cv[ 'VAR:dbp' ] ) {
$_SESSION["last_logged_in"] = time();
$_SESSION["user_type"] = "admin";
$in_str = "";
$submit = "Admin";
$err .= " Logged in as admin";
log_msg( "Admin logged in" );
}
if (	$submit == 'Logout'	
or (	$_SESSION["user_type"] != "guest" 
and ( time() - $_SESSION["last_logged_in"] ) / 60 > 4 * 60 ) ) {
$_SESSION["user_type"] = "guest";
$err .= " You have been logged off.";
$in_str = "";
$submit = "";
}
if (	$_SESSION["user_type"] != "guest" 
and ( time() - $_SESSION["last_logged_in"] ) / 60 > 4 * 55 ) {
$err .= " You are about to be automatically logged off.";
}
if ( $_SESSION["user_type"] == 'admin' and $submit == "Save" and $in_str > "" ) {
$fh = fopen( "$log_dir/program", "w" );
fwrite( $fh, $in_str );
fclose( $fh );
$program = $in_str;
}
if ( $_SESSION["user_type"] == 'admin' and $submit == "Backup" ) {
$backup = "$log_dir/backup";
$fh = fopen( $backup, "w" );
fwrite( $fh, "-- Backup dated " . date( 'ymd H:i' ) . "\n" );
fclose( $fh );
mysql_pconnect('localhost','cms','badsite' ) or die( "failed log in" );
mysql_select_db("newdb") or die( "db" );
$fh = fopen( $backup, "a" );
$sql = "select  t.table_name
from    information_schema.TABLES t
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'";
$sql .= $cv['VAR:tables_sql'];
$result = mysql_query( $sql ) or die( "failed sql" );
while ( list( $tab ) = mysql_fetch_row($result) ) {
fwrite( $fh, "-- reloading table $tab\ndelete from $tab;\n" );
$sql = "select * from $tab";
$result2 = mysql_query( $sql ) or die( "failed sql: '$sql'" );
$c = 0;
while ( $tmp = mysql_fetch_assoc($result2) ) {
$keys = array_keys($tmp); 
$values = array_values($tmp); 
$cmd = 'INSERT INTO ' . $tab . '(' . implode(',', $keys) . 
') VALUES ("' . implode('","', $values) . '");' . "\n"; 
$cmd = ereg_replace( '""','null',$cmd );
fwrite( $fh, $cmd );
$c++;
}
fwrite( $fh, "-- loaded $c records\n" );
}
fwrite( $fh, "-- Finished\n" );
fclose( $fh );
system( "rm -f $log_dir/log" );
$err .= "Backup created in $backup\n\n";
}
$file = `ls $log_dir/compiled`;
if (	$_SESSION["user_type"] == 'admin'
and ( in_array( $submit ,array( "Save", "Admin", "Backup","Restore" ) ) or $file == "" ) ) {
$program = compile_twice();
} else {
if ( ! in_array( $submit ,array( "Search", "Logs", "Report" ) ) ) { $in_str = ""; }
try_logging_in( );
}
if ( ( $submit == "Contact" or $submit == "Send" ) and $cv['VAR:admin_email'] > "" ) {
if ( ! isset( $form["from"] ) ) { $form["from"] = ""; }
if ( ! isset( $form["sub"] ) ) { $form["sub"] = ""; }
if ( ! isset( $form["msg"] ) ) { $form["msg"] = ""; }
if ( $submit == "Send" ) {
if ( ! ereg( $lookup["FORMAT"]["EMAIL"], $form["from"] ) ) {
$err .= "Incorrect email format";
$submit = "Contact";
} elseif ( $form["sub"] == '' ) {
$err .= "No subject";
$submit = "Contact";
} elseif ( $form["msg"] == '' ) {
$err .= "No message";
$submit = "Contact";
}  else {
$headers = "From:" . $form["from"] . "\r\n";
$headers .= "Reply-To:" . $form["from"] . "\r\n";
$headers .= "Content-Type: text/plain;\r\n charset=iso-8859-1\r\n";
$form["sub"] = strip_tags( $cv[ 'VAR:title' ] ) . ": " . $form["sub"];
mail( $cv['VAR:admin_email'], $form["sub"], $form["msg"], $headers );
$err .= "Email sent";
$submit = "";
}
}
}
if ( can_alter_data( $_SESSION["user_type"], $in_tab ) and "$submit" == "Confirm Update" ) {
$sql = "update $in_tab set ";
foreach( array_keys( $form ) as $key ) {
if ( isset( $cv[ "UPPER:$key" ] ) ) { $form[$key] = strtoupper( $form[$key] ); }
if ( isset( $cv[ "LOWER:$key" ] ) ) { $form[$key] = strtolower( $form[$key] ); }
if ( $form[$key] > "" and isset( $cv[ "FORMAT:$key" ] ) ) {
$tmp = $cv[ "FORMAT:$key" ];
$val = $form[$key];
if ( ! ereg( $tmp, $val ) ) {
$err .= " Field $key has wrong format.";
}
}
if ( $form[$key] > "" and isset( $cv[ "BETWEEN:$key" ] ) ) {
$tmp = $cv[ "BETWEEN:$key" ];
$tmp_from = ereg_replace( ':.*', '', $tmp );
$tmp_to = ereg_replace( '.*:', '', $tmp );
$val = $form[$key];
if ( ! ereg( $lookup["FORMAT"]["NUMBER"], $val ) ) {
$err .= " $key must be a number.";
} else {
if ( $val < $tmp_from or $val > $tmp_to ) {
$err .= " $key must be between $tmp_from and $tmp_to.";
}
}
}
if ( $form[$key] > "" ) {
$sql .= " $key = '" . $form[$key] . "',";
} else {
$sql .= " $key = null,";
}
}
$sql = ereg_replace( ',$','', $sql );
$sql .= " where $in_pk = '$in_id'";
if ( $err == "" ) { 
log_sql( $sql );
if ( sql_has_errors( $sql ) ) {
$err .= " Update could not be performed.";
}
}
$in_id = $form[$in_pk];
if ( $err == "" ) {
$submit = "";
} else {
$submit = "Update";
}
} else if ( can_alter_data( $_SESSION["user_type"], $in_tab ) and "$submit" == "Confirm Insert" ) {
$form = $_POST["form"];
$sql = "insert $in_tab ( ";
$values = "";
foreach( array_keys( $form ) as $key ) {
if ( isset( $cv[ "UPPER:$key" ] ) ) { $form[$key] = strtoupper( $form[$key] ); }
if ( isset( $cv[ "LOWER:$key" ] ) ) { $form[$key] = strtolower( $form[$key] ); }
if ( $form[$key] > "" and isset( $cv[ "FORMAT:$key" ] ) ) {
if ( ! ereg( $cv[ "FORMAT:$key" ], $form[$key] ) ) {
$err .= " Field $key has wrong format.";
}
}
if ( $key != "db2web tab" and $form[$key] > "" ) {
$sql .= "$key,";
$values .= "'" . $form[$key] . "',";
}
}
$sql = ereg_replace( ',$','', $sql );
$values = ereg_replace( ',$','', $values );
$sql .= " ) values ( $values )";
if ( $err == "" ) { 
log_sql( $sql );
if ( sql_has_errors( $sql ) ) {
$err .= " Insert could not be performed.";
}
}
$in_id = $form[$in_pk];
if ( $err == "" ) {
$submit = "";
} else {
$submit = "Insert";
}
} else if ( can_alter_data( $_SESSION["user_type"], $in_tab ) and "$submit" == "Confirm Delete" ) {
$form = $_POST["form"];
$sql = "delete from $in_tab where $in_pk = '$in_id'";
log_sql( $sql );
if ( sql_has_errors( $sql ) ) {
$err .= " Delete could not be performed.";
}
$in_id = "";
$in_pk = "";
$submit = "";
} else if ( $_SESSION["user_type"] == 'admin' and "$submit" == "Confirm Restore" ) {
$backup = "$log_dir/backup";
$fh = @fopen($backup, "r") or $err .= " Could not find backup file $backup.";
while ( ! feof( $fh ) ) {
$sql = fgets($fh, 4096);
if ( ereg( '^-- ', $sql ) ) {
$sql = ereg_replace( '^-- ','',$sql );;
$err .= "$sql<br>\n";
} else {
if ( $sql > "" ) {
$result = run_sql( $sql );
}
}
}
$err .= "<br>\n";
fclose( $fh );
} else if ( "$submit" == "Prev" ) {
$id = $in_id;
$show_field = $cv[ "MAIN_COL:$in_tab" ];
$show_field = show_field_for_sql( $in_tab, $show_field, 0 );
$sql = "select $in_pk from $in_tab
where $show_field < (
select $show_field from $in_tab
where $in_pk=" . treat_inp_str( $in_id ) . " )
order by $show_field desc
limit 1";
$result = run_sql( $sql );
list( $in_id ) = mysql_fetch_row($result);
if ( "$in_id" == "" ) { 
$in_id = $id;
$err .= " This is the first record.";
}
$in_id_url = urlencode( $in_id ); 
$submit = "";
} else if ( "$submit" == "Next" ) {
$id = $in_id;
$show_field = $cv[ "MAIN_COL:$in_tab" ];
$show_field = show_field_for_sql( $in_tab, $show_field, 0 );
$sql = "select $in_pk from $in_tab
where $show_field > (
select $show_field from $in_tab
where $in_pk=" . treat_inp_str( $in_id ) . " )
order by $show_field
limit 1";
$result = run_sql( $sql );
list( $in_id ) = mysql_fetch_row($result);
if ( "$in_id" == "" ) { 
$in_id = $id; 
$err .= " This is the last record.";
}
$in_id_url = urlencode( $in_id ); 
$submit = "";
}
try_logging_in( );
if ( $logged_in != 1 ) {
$tmp = array(	"Cannot access database", 
"Cannot log in to database server", 
"No username and password given" );
$_SESSION["last_logged_in"] = time();
$_SESSION["user_type"] = "admin";
$err = $tmp[ $logged_in + 2 ];
}
$title = strip_tags( $cv[ 'VAR:title' ] );
$description = $cv[ 'VAR:description' ];
$col_txt = $cv[ 'VAR:col_txt' ];
$col_tab_bg = $cv[ 'VAR:col_tab_bg' ];
$col_bg = $cv[ 'VAR:col_bg' ];
$col_buttons = $cv[ 'VAR:col_buttons' ];
$desc = "";
if ( $description > "" and $in_tab == "" and $submit == "" and ! $mobile_flg ) { 
$desc = "\n<table width=700><tr><td><i>$description</i></td></tr>\n</table>"; 
}
print( "<html>\n<head>\n<title>" );
if ( $in_pk > "" and $in_id > "" ) {
print( strip_tags( get_name_of( $in_pk,$in_id ) ) );
} else {
print( $title );
}
print( "</title>\n
<META NAME='keywords' content='$title'>
<META NAME='description' content='$title db2web " .
$cv[ 'VAR:version' ] . " database viewer'>
<META HTTP-EQUIV=Pragma CONTENT='no-cache'> 
<META NAME=\"ROBOTS\" CONTENT=\"INDEX,NOFOLLOW\">
<STYLE TYPE=\"text/css\">
<!--
TEXTAREA, SELECT, OPTION, INPUT {
background-color: $col_buttons;
}" );
if ( ! $mobile_flg ) {
if ( isset( $cv[ "VAR:img_bg" ] ) ) {
print( "BODY{
background: white url(" . $cv[ "VAR:img_bg" ] . ") repeat top right;
}" );
}
print( "	H3 {
color: blue ;
}
DT {
color: green ;
font-family: VERDANA ;
font-size: 14;
}
-->
</STYLE>" .
"</head>\n<body link=$col_txt alink=$col_txt vlink=$col_txt bgcolor=$col_bg>\n" .
"<center><b><i><font size=+3>" . $cv[ 'VAR:title' ] .
"</font></i></b><br>$desc \n" );
$p="p";
$target=" target=_popup";
$center="<center>";
$end_center="</center>";
$gap = " &nbsp; &nbsp; ";
$title_sep=" &gt; ";
} else {
$cv['VAR:img_x_size'] = 200;
$cv['VAR:img_y_size'] = 200;
$cv["VERTICAL:$in_tab"] = "";
print( "\n-->\n</STYLE>\n</head>\n<body link=$col_txt alink=$col_txt vlink=$col_txt>\n" );
$p="br";
$target="";
$gap = " ";
$title_sep="&gt;";
}
print( "<form action=${prog} method=POST>" );
$breadcrumb = "<a href=${prog}?submit=Home>Home</a>$title_sep";
if (	$_SESSION["user_type"] == 'admin'
and ( in_array( $submit, array( "Save", "Admin", "Backup" ) ) ) ) {
$breadcrumb .= "Edit program";
show_title( $breadcrumb,"" );
print( "\n<table><tr><td>
<textarea name=str rows=20 cols=80>$program</textarea>
</td></tr>\n</table>" );
$done_flg = 1;
} else {
if ( $submit == "Search" ) {
$tmp = "%" . ereg_replace( ' ', '%', $in_str ) . "%";
$sql = $cv[ "SQL_SEARCH" ] . " limit " . $cv[ "VAR:max_show" ];
$sql = ereg_replace( 'INPUT_STR', $tmp, $sql );
$tmp_sql = "select count(*) from ( $sql ) x";
$result = run_sql( $tmp_sql );
list( $cnt ) = mysql_fetch_row($result);
if ( $cnt != 1 ) { $msg .= "Found $cnt matches"; }
if ( $cnt == 1 ) {
$in_str = "";
$result = run_sql( $sql );
list( $url ) = mysql_fetch_row($result);
$tmp = split( '[\?&>]', $url );
foreach( $tmp as $assign ) {
if ( ereg( '^id=', $assign ) ) {
$assign = ereg_replace( '^.*=', '', $assign );
$in_id = urldecode( $assign );
$in_id_url = urlencode( $in_id );
} else if ( ereg( '^tab=', $assign ) ) {
$assign = ereg_replace( '^.*=', '', $assign );
$tab = urldecode( $assign );
$in_tab = $tab;
} else if ( ereg( '^pk=', $assign ) ) {
$assign = ereg_replace( '^.*=', '', $assign );
$in_pk = urldecode( $assign );
}
}
if ( ! ( $tab > "" and $in_pk > "" and $in_id > "" ) ) {
$done_flg = 1;
$breadcrumb .= "Searching for $in_str";
$in_tab = "";
$tab = "";
$in_pk = "";
$in_id = "";
}
} else {
$done_flg = 1;
}
} else if ( $submit == "Report"  ) {
$str = urldecode( $in_str );
$breadcrumb .= "$str";
if ( $cv[ "REPORT::$str" ] > "" ) {
$sql = $cv[ "REPORT::$str" ];
} else {
$sql = $cv[ "REPORT:$in_pk:$str" ];
if ( ereg( '\{ID\}', $sql ) and $in_id > "" ) {
$sql = ereg_replace( '\{ID\}', $in_id, $sql );
$breadcrumb .= " (" . get_name_of( $in_pk,$in_id ) . ")";
}
}
$in_pk = "";
$in_tab = "";
$in_str = "";
$done_flg = 1;
$cnt=99;
} 
if ( ! $done_flg ) {
$tab = $in_tab;
if ( $tab == "" ) {
if ( ereg( "^TABLE:", $cv["START"] ) ) {
$tab = ereg_replace( "^TABLE:", "", $cv["START"] );
}
if ( isset( $cv[ "PICK:$tab" ] ) ) {
$sql = "select count(*) from $tab";
$result = run_sql( $sql );
list( $cnt ) = mysql_fetch_row($result);
if ( $cnt > 0 ) {
$r = rand( 1,$cnt );
$in_pk = $cv[ "PK:$tab" ];
$sql = "select max($in_pk) from ( select $in_pk from $tab limit $r ) x";
$result = run_sql( $sql );
list( $in_id ) = mysql_fetch_row($result);
$in_id_url = urlencode( $in_id );
}
}
}
$in_tab=$tab;
$show_field = $cv[ "MAIN_COL:$tab" ];
$tab_pk = $cv[ "PK:$tab" ];
$show_field = show_field_for_sql( $tab, $show_field, 0 );
$sql = "select (DATA) from $tab t where 1=1";
if ( "$in_pk" > "" and "$in_id" > "" ) {
$sql .= " and $in_pk = " . treat_inp_str( $in_id );
}
if ( "$from" > "" or "$to" > "" ) {
$tmp_from = urldecode( $from );
$tmp_from = treat_inp_str( urldecode( $from ) );
$tmp_to = treat_inp_str( urldecode( $to ) );
$sql .= " and $show_field between $tmp_from and $tmp_to";
}
if ( $submit == "Recent items" ) {
$tmp_sql = "";
foreach( $_SESSION["recent_items"] as $tmp ) {
$tmp_tab = ereg_replace( ':.*','',$tmp );
$tmp_id = ereg_replace( '.*:','',$tmp );
if ( $tmp_tab == $tab ) { 
if ( $tmp_sql > "" ) {
$tmp_sql .= ",'$tmp_id'";
} else {
$tmp_sql = " and $tab_pk in ('$tmp_id'";
}
}
}
if ( $tmp_sql > "" ) { $tmp_sql .= ")"; }
$sql .= $tmp_sql;
}
$tmp_sql = ereg_replace( '\(DATA\)','count(*)',$sql );
$result = run_sql( $tmp_sql );
list( $cnt ) = mysql_fetch_row($result);
if ( ! $mobile_flg ) {
if ( ereg( '\(', $tmp_msg ) ) { $tmp_msg .= " &nbsp;"; } else { $tmp_msg .= "("; }
if ( $in_limit != -1 and $cnt > $cv[ 'VAR:max_show' ] or "$from" > ""  ) {
$tmp_msg .= " <a href=$prog?tab=$tab&pk=$in_pk&limit=-1&a=6&id=$in_id_url>" .
"List all</a>\n";
} else {
$tmp_msg .= " List all";
}
if ( ereg( '\(', $tmp_msg ) ) { $tmp_msg .= " &nbsp;"; } else { $tmp_msg .= "("; }
if ( "$in_limit" != "0" and $cnt > $cv[ 'VAR:max_show' ] or "$from" > "" ) {
$tmp_msg .=	" <a href=$prog?tab=$tab&pk=$in_pk&from=" .
urlencode($from) . "&to=" . urlencode($to) . 
"&a=7&id=$in_id_url>Show range</a>";
} else {
$tmp_msg .= " Show range";
}
if ( ereg( '\(', $tmp_msg ) ) { $tmp_msg .= " &nbsp;"; } else { $tmp_msg .= "("; }
if ( $in_limit != -2 and $cnt > 1 ) {
$tmp_msg .=	" <a href=$prog?tab=$tab&pk=$in_pk&limit=-2&from=" .
urlencode($from) . "&to=" . urlencode($to) . 
"&a=8&id=$in_id_url>Show all associated data</a>";
} else {
$tmp_msg .= " Show all associated data";
}
$tmp_msg .= " )<br>";
if ( ereg( 'href', $tmp_msg ) ) { $msg .= $tmp_msg; }
}
if ( ! in_array( $submit ,array( "Insert", "Update", "Delete", "Clear" ) ) ) { 
if ( $cnt == 1 and "$in_id" > "" and ! ereg( 'concat',$in_pk ) ) {
$msg .= "\n<a href=${prog}?tab=$tab&pk=$in_pk&submit=Prev&a=9&id=$in_id_url>" .
"Prev</a>\n &nbsp; &nbsp; " .
"<a href=${prog}?tab=$tab&pk=$in_pk&submit=Next&a=10&id=$in_id_url>" .
"Next</a>\n";
} else {
if ( $cnt > 0 ) { $msg .= "$cnt items found"; }
if ( "$from" > "" or "$to" > "" ) {
$msg .= " between <i>" . substr(urldecode($from),0,30) . "</i> and <i>" .
substr(urldecode($to),0,30) . 
"</i>";
}
}
}
if ( $mobile_flg and $cv[ 'SQL_SEARCH' ] > "" ) {
$msg .= " &nbsp; &nbsp; " .
"\n<input type=text name=str value='$in_str' size=5>" .
" <input type=submit name=submit value=Search>";
}
if (	can_alter_data( $_SESSION["user_type"], $in_tab ) 
and in_array( $submit ,array( "Insert", "Update", "Delete", "Clear" ) ) ) {
$range_flg = 0;
$sql = ereg_replace( '\(DATA\)','*', $sql );
$sql .= " limit 1";
$msg = "";
} else if ( $cnt == 1 or $in_limit == -2 ) {
$range_flg = 0;
$sql = ereg_replace( '\(DATA\)',
$cv[ "SQL_SHOW:$in_tab" ],
$sql );
} else if ( $cnt <= $cv[ 'VAR:max_show' ] or $in_limit == -1 ) {
$range_flg = 0;
$sql = ereg_replace( '\(DATA\)',
"concat('<a href=${prog}?tab=$tab&pk=$tab_pk&a=11&id=',$tab_pk,'>',
$show_field,'</a>' ) as data",
$sql );
$sql .= " order by $show_field limit " . $cv[ "VAR:max_all_show" ];
} else {
$range_flg = 1;
$num = (int) ( $cnt / $cv[ 'VAR:max_groups' ] );
if ( $num < 5 ) { $num = 5; }
$tmp = $sql;
$tmp_show = show_field_for_sql( $tab, $show_field, 0 );
$sql = "select 'range' type, 
min(name) range_min, max(name) range_max
from (  select (@rownum:=@rownum+1) rn ,name
from    (" .
ereg_replace( '\(DATA\)', "$tmp_show as name", $tmp) .
" order by $tmp_show ) x,
(SELECT @rownum:=-1) r
) y
group by rn div $num";
}
$breadcrumb .= "<a href=${prog}?tab=$tab>" . 
get_table_name( $tab,1 ) . "</a>$title_sep";
if ( in_array( $submit ,array( "Insert", "Update", "Delete", "Clear",
"Confirm Insert", "Confirm Update", "Confirm Delete" ) ) ) {
$breadcrumb .= "$submit " . get_table_name($in_tab);
} else if ( $in_pk > "" and $in_id > "" ) {
if ( $in_pk != $cv[ "PK:$in_tab" ] ) {
$breadcrumb .= get_table_name( $in_tab,1 ) . 
" linked to " . 
get_name_of( $in_pk,$in_id );
} else {
$breadcrumb .= get_name_of( $in_pk,$in_id );
}
} else if ( $submit == "Recent items" ) {
$breadcrumb .= "Recent items";
} else {
$breadcrumb .= "All";
}
}
show_title( $breadcrumb,$msg );
$result = run_sql( $sql );
$c = 0;
$tab_pk = $cv["PK:$in_tab"];
print( "<table " );
if ( ! $mobile_flg ) { print( " bgcolor=$col_tab_bg" ); }
if (	( $submit == "Report" 
or $in_limit == -2  
or $cv["VAR:borders"] > 0
or $cnt == 1 and ! isset( $cv["VERTICAL:$in_tab"] ) )
and ! $mobile_flg  ) { 
print( " border=1" ); 
}
if ( ! $mobile_flg and $cnt == 1 and isset( $cv["VERTICAL:$in_tab"] ) ) {
print( " width=600" );
}
print( ">\n" );
if ( $cnt == 0 ) {
if ( count( $form ) > 0 ) {
foreach( array_keys( $form ) as $key ) {
$row[ $key ] = $form[ $key ];
}
display_fields( $in_tab, $submit, $form );
} else if ( $submit == "Insert" or $submit == "Clear" ) {
$sql = "select	s.column_name
from    information_schema.COLUMNS s
where   s.table_name = '$in_tab'
and s.table_schema = schema()";
$result = run_sql( $sql );
while( list( $key ) = mysql_fetch_row($result) ) {
if (  $key == $in_pk and $in_id > "" ) {
$row[$key] = $in_id;
} else {
$row[$key] = "";
}
}
display_fields( $in_tab, $submit, $row );
} else {
print( "<tr><td><font size=+1> &nbsp; No data found &nbsp; </font></td></tr>" );
}
}
while( $row = mysql_fetch_array( $result,MYSQL_ASSOC ) ) {
print( "<tr>" );
if ( "$submit" == "Clear" ) {
foreach( array_keys( $row ) as $key ) {
$row[ $key ] = "";
}
foreach( array_keys( $form ) as $key ) {
$form[ $key ] = "";
}
$submit = "Insert";
}
if (	can_alter_data( $_SESSION["user_type"], $in_tab ) 
and in_array( $submit ,array( "Insert", "Update", "Delete" ) ) ) {
display_fields( $in_tab, $submit, $row );
} else if ( $cnt == 1 and isset( $cv[ "VERTICAL:$in_tab"] ) ) {
$done_field = "";
foreach( array_keys( $row ) as $key ) {
if ( ereg( '<img ', print_data_item( $submit, $in_tab, $key, $row[$key], 
$cnt, $in_pk, $in_id, 0 ) ) and $done_field == "" ) {
print( "<td colspan=2>" );
print( print_data_item( $submit, $in_tab, $key, $row[$key], 
$cnt, $in_pk, $in_id, 0 ) );
print( "</td>\n" );
$done_field = $key;
}
}
if ( $mobile_flg ) {
print( "</tr><tr>\n" );
} else {
print( "<td>\n<table>\n" );
}
foreach( array_keys( $row ) as $key ) {
if (	$mobile_flg 
and print_data_item( $submit, $in_tab, $key, $row[$key], 
$cnt, $in_pk, $in_id, 0 ) == "" ) {
continue;
}
if ( $key != $done_field ) {
print( "<tr><td><b>" .
get_field_name($key) .
"</b></td><td>" .
print_data_item( $submit, $in_tab, $key, $row[$key], 
$cnt, $in_pk, $in_id, 0 ) .
"</td></tr>\n" );
}
}
print( "\n</table>\n</td>\n" );
} else {
if ( $c == 0 and ! $range_flg  ) {
$tmp = array_keys( $row );
if ( count( $row ) != 1 and $tmp[0] != "data") {
echo "<tr>";
foreach( array_keys( $row ) as $key ) {
print( "<th><b>" . get_field_name($key) ."</b></th>" );
}
echo "</tr>";
}
}
if ( $range_flg ) {
$from = $row["range_min"];
$to = $row["range_max"];
print( "<td><a href=${prog}?tab=$tab&from=" .
urlencode($from) . "&to=" .
urlencode($to) . "&pk=$in_pk&a=12&id=$in_id_url>" . substr($from,0,30) . 
" &nbsp; <font color=black><b>&lt;---&gt;</b></font> &nbsp; " .
substr($to,0,30) . "</a></td>\n" );
} else {
foreach( array_keys( $row ) as $key ) {
$data = $row[ $key ];
print( print_data_item( $submit, $tmp[$key], $key, $data, 
$cnt, $in_pk, $in_id, 1 ) );
print( "</td>" );
}
}
}
print( "</tr>\n" );
$c ++;
}
show_alter_buttons( $in_tab, $submit, $cnt, $in_pk, $in_id );
print( "\n</table>\n<$p>" );
$sql = "select  '$in_pk', s.table_name
from    information_schema.TABLES t,
information_schema.COLUMNS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.table_name = t.table_name 
and t.table_name != '$in_tab'
and s.column_name = '$in_pk'
and s.table_schema = schema()";
$sql .= $cv['VAR:tables_sql'];
if ( isset( $cv[ "LINK2:$in_tab:$in_pk" ] ) ) {
$tmp = split( ':',$cv[ "LINK2:$in_tab:$in_pk" ] );
$tmp_tab = $tmp[0];
$tmp_field = $tmp[1];
$sql .= " union select '$tmp_field', '$tmp_tab' from dual";
}
$result = run_sql( $sql );
print( "$center\n<table>\n<tr><td>\n" );
while( list( $field, $tmp ) = mysql_fetch_row($result) ) {
$res = array();
if ( $tmp != $in_tab or $field != $in_pk ) {
$sql = "select count(*) from $tmp where $field = " . treat_inp_str( $in_id );
$result2 = run_sql( $sql );
list( $cnt ) = mysql_fetch_row($result2);
if ( $cnt > 0 and $cnt < $cv['VAR:max_linked_list'] ) {
$fk_show = $cv[ "MAIN_COL:$tmp" ];
$fk_pk = $cv[ "PK:$tmp" ];
$sql = "select	s.column_name
from    information_schema.COLUMNS s
where   s.table_name = '$tmp'
and s.table_schema = schema()";
$fk_cnt = 0;
$url_cnt = 0;
$other_cnt = 0;
$url_field = "";
$result2 = run_sql( $sql );
while( list( $col ) = mysql_fetch_row($result2) ) {
if ( isset( $cv["FK:$col"] ) ) { 
$fk_cnt ++; 
} else if ( isset( $cv["URL:$tmp:$col"] ) ) { 
$url_cnt ++;
$url_field = $col;
} else {
$other_cnt ++;
}
}
if ( $fk_cnt == 1 and $url_cnt == 1 and $other_cnt == 1 ) {
$sql = "select $url_field,$fk_pk,$fk_show from $tmp where $in_pk=" . 
treat_inp_str( $in_id );
$result2 = run_sql( $sql );
while( list( $url, $tmp_id,$tmp_name ) = mysql_fetch_row($result2) ) {
$txt = "<a href=$url $target>$tmp_name</a>";
if ( can_alter_data( $_SESSION["user_type"], $tmp ) ) {
$txt .= " (<a href=${prog}?tab=$tmp&pk=$fk_pk&a=20&id=" . 
urlencode($tmp_id) . 
"><font color=green>edit</font></a>)";
}
$res[] = "$txt\n";
}
} else {
$sql = "select $fk_pk,$fk_show from $tmp where $in_pk=" . 
treat_inp_str( $in_id );
$result2 = run_sql( $sql );
while( list( $tmp_id,$tmp_name ) = mysql_fetch_row($result2) ) {
$res[] = "<a href=${prog}?tab=$tmp&pk=$fk_pk&a=20&id=" . 
urlencode($tmp_id) . ">$tmp_name</a>\n";
}
}
} else {
if ( $cnt > 0 ) {
$txt = "<a href=${prog}?tab=$tmp&pk=$field&a=13&id=$in_id_url>" .
"$cnt matches</a>";
} else {
$txt = "$cnt matches";
}
if ( can_alter_data( $_SESSION["user_type"], $tmp ) ) {
$txt .= " (<a href=${prog}?submit=Insert&tab=$tmp&pk=$in_pk&a=13&" .
"id=$in_id_url><font color=green>add</font></a>)";
}
$res[] = $txt;
}
if ( count( $res ) == 0 ) {
} else if( ! $mobile_flg ) {
print( "<center><b>" . 
get_table_name( $tmp,1 ) . " :</b> " . 
implode( ' , ', $res ) . 
"</center>" );
} else {
print( "<b>" . get_table_name( $tmp,1 ) . " :</b><ul><li>" . 
implode( '<li>', $res ) . 
"</ul>" );
}
}
}
print( "</td></tr>$end_center\n" );
}
if ( $err > "" ) { 
if ( strlen( $err ) > 400 ) { $err = substr( $err,0,400 ); }
print( "<tr><td>$center<font color=red>$err</font><$p>$end_center</td></tr>" ); 
}
$special_rpts = "";
$available_tables = "";
if (	in_array( $submit ,array( "Save", "Admin", "Tables", "Internal","Logs","Backup","Restore" ) )
and ! $mobile_flg
and $_SESSION["user_type"] == 'admin' ) { 
print( "<tr><td><center>\n" );
if ( in_array( $submit ,array( "Save", "Admin", "Backup" ) ) ) {
print( "<input type=submit name=submit value=Save>" );
} else {
print( "<input type=submit name=submit value=Admin>" );
}
print( " &nbsp; &nbsp; <input type=submit name=submit value=Home>" );
print( " &nbsp; &nbsp; <input type=submit name=submit value=Tables>" ); 
print( " &nbsp; &nbsp; <input type=submit name=submit value=Logout><p>" ); 
print( "</center></td></tr>\n" );
} else {
print( "<tr><td><center>\n" );
print( "<input type=hidden name=tab value='$in_tab'>\n" .
"<input type=hidden name=pk value='$in_pk'>\n" .
"<input type=hidden name=id value='$in_id'>\n" );
if ( ! $mobile_flg ) {
if ( $cv[ 'SQL_SEARCH' ] > "" ) {
print( "<p><input type=text name=str size=10 value='$in_str' bgcolor=yellow> &nbsp;
<input type=submit name=submit value=Search>" );
print( str_repeat( " &nbsp; ",8 ) );
}
if ( $cv['VAR:admin_email'] > "" and ! $mobile_flg ) {
print( "&nbsp; &nbsp; <input type=submit name=submit value=Contact>" ); 
}
if ( $_SESSION["user_type"] == 'admin' ) { 
print( " &nbsp; &nbsp; <input type=submit name=submit value=Admin>" ); 
}
if ( $_SESSION["user_type"] != 'guest' ) { 
print( " &nbsp; &nbsp; <input type=submit name=submit value=Logout> &nbsp; " ); 
}
}
print( "</center></td></tr>\n" );
foreach( array_keys( $cv ) as $key ) {
if ( ereg( '^REPORT::', $key ) or ereg( "^REPORT:$in_pk:", $key ) ) {
$name = ereg_replace( '.*:', '', $key );
if ( $in_pk > "" and ereg( "^REPORT:$in_pk:", $key ) ) { $special_rpts .= "<b>"; }
$special_rpts .= "<li><a href=${prog}?submit=Report&str=" .
urlencode( $name ) . "&a=15";
if ( ereg( "^REPORT:$in_pk:", $key ) ) { $special_rpts .= "&pk=$in_pk&id=$in_id_url"; }
$special_rpts .= ">$name</a>\n";
if ( $in_pk > "" and ereg( "^REPORT:$in_pk:", $key ) ) { $special_rpts .= "</b>"; }
}
}	
foreach( array_keys( $cv ) as $key ) {
if ( ereg( '^PK:', $key ) ) {
$name = ereg_replace( '.*:', '', $key );
$available_tables .= "<li><a href=${prog}?tab=$name>" .
get_table_name( $name,1 ) . "</a>\n";
}
}	
if ( $cv[ 'VAR:max_recent_items' ] > 0 ) { 
$available_tables .= "<li><a href=${prog}?tab=$in_tab&limit=-2&submit=Recent%20items>" .
"Compare recent items</a>\n";
}
print( "<tr><td>$center\n" );
if ( ! $mobile_flg ) {
print( "<table width=750><tr valign=top><td width=33%>\n" );
if ( $special_rpts > "" ) {
print( "\n<b>Reports:</b><ul>
$special_rpts</ul>\n" );
}
print( "</td><td width=33%><b>Lists:</b><ul>\n$available_tables</ul></td>" );
print( $cv["VAR:all_systems" ] );
print( "</tr>\n</table>\n" );
} else {
print( "\n<b>Lists:</b><ul>$available_tables</ul><br>" );
}
print( "$end_center</td></tr>\n" );
if ( isset( $cv[ 'VAR:info' ] ) and ! $mobile_flg ) {
print( "<tr><td><center><font size=-1><i>" . $cv[ 'VAR:info' ] . 
"</i></font></center></td></tr>" );
}
}
print( "\n</table>\n" );
if ( ! $mobile_flg ) {
print( "\n<table width=400><tr>
<td align=left>
<a href=${prog}?submit=Mobile&tab=$in_tab&pk=$in_pk&a=15&id=" . 
urlencode( $in_id ) . 
"><font size=-1>View on mobile</font></a></td>
<td align=right>
<a href=$db2web_home $target>
<font size=-1>db2web (" . $cv[ 'VAR:version' ] . ")</font></a>
</td></tr>\n</table>
</center>" );
} else {
print( "<a href=${prog}?submit=Mobile&tab=$in_tab&pk=$in_pk&a=15&id=" . 
urlencode( $in_id ) . 
">View full screen</a>" );
}
print( "</form>\n</body>\n</html>" );
if ( $in_id > "" and $in_tab > "" ) {
if ( in_array( "$in_tab:$in_id", $_SESSION["recent_items"] ) ) {
$_SESSION["recent_items"] = array_diff( $_SESSION["recent_items"], array( "$in_tab:$in_id" ) );
}
if ( count( $_SESSION["recent_items"] ) >= $cv[ 'VAR:max_recent_items' ] ) { 
array_shift( $_SESSION["recent_items"] );
}
$_SESSION["recent_items"][] = "$in_tab:$in_id";
}
$pid=`echo $$`;
$pid = $pid % 100;
if ( $pid == 0 ) {
$size = $cv[ 'max_logs' ];
system( "tail -$size $log_dir/log > $log_dir/tmp; mv $log_dir/tmp $log_dir/log" );
log_msg( "Truncated log" );
}
exit;
function lookup_preset( $type, $word ) {
GLOBAL $lookup;
GLOBAL $err;
if ( ereg( '^[A-Za-z_]+$', $word ) ) {
if ( isset( $lookup["$type"][$word] ) ) {
return( $lookup["$type"][$word] );
} else {
$err .= "Unknown preset values $word, allowed preset values are: " .
implode( ', ' , array_keys( $lookup["$type"] ) ) . ".";
}
}
return $word;
}
function compile_twice( ) {
GLOBAL $cv;
GLOBAL $main_dir;
GLOBAL $err;
$cv = array();
$cv[ 'VAR:version' ] = '0.9f';
if ( ! isset( $cv[ 'VAR:col_txt' ] ) ) { $cv[ 'VAR:col_txt' ] = 'blue'; }
if ( ! isset( $cv[ 'VAR:col_bg' ] ) ) { $cv[ 'VAR:col_bg' ] = 'lightgrey'; }
if ( ! isset( $cv[ 'VAR:col_tab_bg' ] ) ) { $cv[ 'VAR:col_tab_bg' ] = 'lightgreen'; }
if ( ! isset( $cv[ 'VAR:col_buttons' ] ) ) { $cv[ 'VAR:col_buttons' ] = '#FFFF99'; }
if ( ! isset( $cv[ 'VAR:max_show' ] ) ) { $cv[ 'VAR:max_show' ] = 50; }
if ( ! isset( $cv[ 'VAR:max_linked_list' ] ) ) { $cv[ 'VAR:max_linked_list' ] = 12; }
if ( ! isset( $cv[ 'VAR:max_radio_list' ] ) ) { $cv[ 'VAR:max_radio_list' ] = 4; }
if ( ! isset( $cv[ 'VAR:max_groups' ] ) ) { $cv[ 'VAR:max_groups' ] = 15; }
if ( ! isset( $cv[ 'VAR:max_all_show' ] ) ) { $cv[ 'VAR:max_all_show' ] = 500; }
if ( ! isset( $cv[ 'VAR:max_logs' ] ) ) { $cv[ 'VAR:max_logs' ] = 1000; }
if ( ! isset( $cv[ 'VAR:title' ] ) ) { $cv[ 'VAR:title' ] = "db2web"; }
if ( ! isset( $cv[ 'VAR:description' ] ) ) { $cv[ 'VAR:description' ] = ""; }
if ( ! isset( $cv[ 'VAR:url_base_dir' ] ) ) { $cv[ 'VAR:url_base_dir' ] = ""; }
if ( ! isset( $cv[ 'VAR:img_x_size' ] ) ) { $cv[ 'VAR:img_x_size' ] = 300; }
if ( ! isset( $cv[ 'VAR:img_y_size' ] ) ) { $cv[ 'VAR:img_y_size' ] = 300; }
if ( ! isset( $cv[ 'VAR:img_x_size_small' ] ) ) { $cv[ 'VAR:img_x_size_small' ] = 40; }
if ( ! isset( $cv[ 'VAR:img_y_size_small' ] ) ) { $cv[ 'VAR:img_y_size_small' ] = 40; }
if ( ! isset( $cv[ 'VAR:tables' ] ) ) { $cv[ 'VAR:tables' ] = ""; }
if ( ! isset( $cv[ 'VAR:tables_sql' ] ) ) { $cv[ 'VAR:tables_sql' ] = ""; }
if ( ! isset( $cv[ 'VAR:borders' ] ) ) { $cv[ 'VAR:borders' ] = "0"; }
if ( ! isset( $cv[ 'VAR:max_recent_items' ] ) ) { $cv[ 'VAR:max_recent_items' ] = "5"; }
$orig_err = $err;
$program = build_compiled_file( );
unset_all_but_vars( );
$err = $orig_err;
$cv["VAR:all_systems" ] = "";
$cnt = 0;
$systems = `ls $main_dir`;
foreach( split( "\n", $systems ) as $system ) {
if ( $system > "" ) {
$cnt ++;
$tmp = file_get_contents( "$main_dir/$system/compiled" );
$tmp_array = unserialize( $tmp );
$cv["VAR:all_systems" ] .= "<li><a href=../$system/$prog>" . 
strip_tags($tmp_array["VAR:title"]) . "</a>"; 
}
}
if ( $cnt > 1 ) {
$cv["VAR:all_systems" ] = "\n<td width=33%><b>Other systems:</b><ul>" .
$cv["VAR:all_systems" ] .= "</ul></td>";
} else {
$cv["VAR:all_systems" ] = "";
}
$program = build_compiled_file( );
return $program;
}
function unset_all_but_vars( ) {
GLOBAL $cv;
foreach( array_keys( $cv ) as $key ) {
if ( ! ereg( '^VAR:',$key ) ) {
unset( $cv[$key] );
}
}
}
function fk_details( $tab, $field ) {
GLOBAL $cv;
if ( isset( $cv["LINK1:$tab:$field"] ) ) {
$tmp = $cv["LINK1:$tab:$field"];
$fk_tab = ereg_replace( ':.*', '', $tmp );
$fk_pk = ereg_replace( '.*:', '', $tmp );
} else if ( isset( $cv["FK:$field"] ) ) {
$fk_tab = $cv["FK:$field"];
$fk_pk = $cv["PK:$fk_tab"];
}
if ( $fk_tab > "" and ( $tab != $fk_tab or $fk_pk != $field ) ) {
$fk_show = $cv["MAIN_COL:$fk_tab"];
$tab_name = get_table_name( $fk_tab,0 );
if ( $tab_name == "" ) { $tab_name = $tab; }
return( array( "tab" => $fk_tab, "pk" => $fk_pk, "show" => $fk_show, "tab_name" => $tab_name ) );
} else {
return array();
}
}
function show_alter_buttons( $tab, $submit, $cnt, $pk, $id ) {
GLOBAL $cv;
if (	can_alter_data( $_SESSION["user_type"], $tab ) 
or $submit == "Restore" and $_SESSION["user_type"] == "admin" ) {
if ( $submit == "Delete" ) {
print( "<tr><td> &nbsp; <center><b>" . get_name_of( $pk,$id ) . "</b></center></td></tr>\n" );
}
if ( $submit != "Recent items" ) {
print( "<tr><td colspan=20><br><center>" );
if ( in_array( $submit ,array( "Insert", "Update", "Delete", "Restore" ) ) ) {
print( "<input type=submit name=submit value='Confirm $submit'> &nbsp;
<input type=submit name=submit value=Cancel>" );
if ( $submit == "Insert" ) {
print( " &nbsp; <input type=submit name=submit value=Clear>" );
}
} else {
if ( $cnt == 1 and $id > "" ) {
print( "<input type=submit name=submit value=Update> &nbsp;
<input type=submit name=submit value=Delete> &nbsp; " );
}
print( "<input type=submit name=submit value=Insert>" );
}
print( "<p></center></td></tr>\n" );
}
}
}
function display_fields( $tab, $submit, $row ) {
GLOBAL $cv;
foreach( array_keys( $row ) as $key ) {
if ( isset( $cv["HIDE:$tab:$key"] ) ) {
continue;
}
$field_name = get_field_name( $key );
if ( $submit == "Insert" and isset( $cv[ "DEFAULT:$key" ] ) ) {
$row[ $key ] = $cv[ "DEFAULT:$key" ];
}
if ( $key != $tab_pk and $submit == "Delete" ) {
$key = $key;
} else if (	count( fk_details( $tab, $key ) ) > 0 
or isset( $cv["FIELD_VALUES:$key"] ) ) {
$fk_details = fk_details( $tab, $key ); 
$fk_tab = $fk_details["tab"];
$fk_pk = $fk_details["pk"];
$fk_show = $fk_details["show"];
$name = "form[$key]";
$vals = array();
if ( isset( $cv["FIELD_VALUES:$key"] ) ) {
foreach( split( ',' , $cv["FIELD_VALUES:$key"] ) as $val ) {
$vals["$val"] = $val;
}
} else {
$tmp_sql = "select $fk_pk, $fk_show from $fk_tab " .
"order by $fk_show limit " .
$cv[ 'VAR:max_all_show' ];
$result2 = run_sql( $tmp_sql );
while( list( $fk_id, $fk_name ) = mysql_fetch_row($result2) ) {
$vals["$fk_id"] = $fk_name;
}
}
if ( count( $vals ) >= $cv['VAR:max_radio_list'] ) {
print( "<tr><td><b>$field_name</td><td><select name='$name'>" );
foreach( array_keys( $vals ) as $k ) {
if ( "$k" == $row[ $key ] ) {
print( "<option value='$k' selected>" . $vals["$k"] . "</option>\n" );
} else {
print( "<option value='$k'>" . $vals["$k"] . "</option>\n" );
}
}
print( "</select>" );
} else {
print( "<tr><td><b>$field_name</td><td>" );
foreach( array_keys( $vals ) as $k ) {
print( " &nbsp; " );
if ( $k == $row[ $key ] ) {
print( "<input type=radio name='$name' value='$k' checked>" . $vals["$k"] );
} else {
print( "<input type=radio name='$name' value='$k'>" . $vals["$k"] );
}
}
}
print( "</td></tr>\n" );
} else {
print( "<tr><td><b>$field_name</td>" .
"<td><input type=text size=60 name='form[$key]' value='" . 
$row[$key] . "'></td></tr>\n" );
}
}
}
function can_alter_data( $user_type, $tab ) {
GLOBAL $cv;
GLOBAL $mobile_flg;
if ( $mobile_flg ) {
return 0;
} else if (	$user_type == "admin" and $cv[ "EDIT:$tab" ] > ""
or $cv[ "EDIT:$tab" ] == "GUEST"
or $user_type == "special" and $cv[ "EDIT:$tab" ] == "SPECIAL" ) {
return 1; 
} else {
return 0; 
}
}
function show_title( $breadcrumb,$msg ) {
GLOBAL $mobile_flg;
if ( $mobile_flg ) {
print( "$breadcrumb<br>\n" );
} else {
print( "<b><i><font size=+1>$breadcrumb</font></i></b><p>\n" );
}
if ( $msg > "" ) {
print( "<font size=-1>$msg</font>\n" );
}
$breadcrumb = trim( strip_tags( $breadcrumb ) );
$breadcrumb = ereg_replace( "[\n ]+", ' ', $breadcrumb );
$breadcrumb = ereg_replace( '&gt;', '>', $breadcrumb );
log_msg( $breadcrumb );
}
function log_sql( $msg ) {
GLOBAL $ip;
GLOBAL $log_dir;
$msg = "-- " . date( 'ymd H:i' ) . "     $ip\n$msg;\n\n";
$fh = fopen( "$log_dir/sql", "a" );
fwrite( $fh, $msg );
fclose( $fh );
}
function log_msg( $msg ) {
GLOBAL $ip;
GLOBAL $log_dir;
$msg = date( 'ymd H:i' ) . " $ip $msg\n";
$fh = fopen( "$log_dir/log", "a" );
fwrite( $fh, $msg );
fclose( $fh );
}
function show_field_for_sql( $tab, $field, $rename_flg ) {
GLOBAL $cv;
GLOBAL $prog;
GLOBAL $err;
$val = $field;
$val_name = $field;
if ( isset( $cv["HIDE:$tab:$field"] ) ) {
return '';
}
if ( $cv["PK:$tab"] == $field ) {
if ( $rename_flg ) {
$val="concat('<a href=${prog}?tab=$tab&pk=$field&a=1&id=',$field,'>',$field,'</a>')";
} else {
$val = $field;
}
}
if ( $cv["MAIN_COL:$tab"] == $field and $cv["PK:$tab"] > "" ) {
$pk = $cv["PK:$tab"];
if ( $field != $pk ) {
$tmp="if($field>'',$field,$pk)";
} else {
$tmp = $field;
}
if ( $rename_flg ) {
$val="concat('<a href=${prog}?tab=$tab&pk=$pk&a=2&id=',$pk,'>',$tmp,'</a>')";
} else {
$val=$tmp;
}
$val_name = get_table_name( $tab,0 );
}
if ( count( fk_details( $tab, $field ) ) > 0 ) {
$fk_details = fk_details( $tab, $field ); 
$fk_tab = $fk_details["tab"];
$fk_pk = $fk_details["pk"];
$fk_show = $fk_details["show"];
$val_name = $fk_details["tab_name"];
if ( $rename_flg ) {
$val="ifnull((select max(concat('<a href=${prog}?tab=$fk_tab&pk=$fk_pk&a=3&id='," .
"f.$fk_pk,'>',f.$fk_show,'</a>')) " .
"from $fk_tab f where f.$fk_pk=t.$field)," .
"concat( 'No " . get_table_name( $fk_tab,1 ) . " record for id ', t.$field))";
} else {
$val = "ifnull((select max(f.$fk_show) " .
"from $fk_tab f where f.$fk_pk=t.$field)," .
"concat( 'No " . get_table_name( $fk_tab,1 ) . " record for id ', t.$field))";
}
}
if ( $val != $val_name and $rename_flg ) {
$val = "$val as " . quoted( "$field" );
}
return $val;
}
function sql_has_errors( $sql ) {
GLOBAL $err;
$sql = ereg_replace( '\{ID\}', "0", $sql );
$tmp = $err;
$result = run_sql( $sql );
while( $row = mysql_fetch_array( $result,MYSQL_ASSOC ) ) {
$sql = $sql;
}
if ( $tmp != $err ) {
$err = $tmp;
return( 1 );
} else {
return( 0 );
}
}
function run_sql( $sql ) {
GLOBAL $cv;
GLOBAL $err;
$sql = ereg_replace( "[".chr(0x01)."-".chr(0x1F)."]", " ", $sql );
$sql = ereg_replace( "[ \t]+", " ", $sql );
$retry = 0;
$result=mysql_query( $sql ) or $retry = 1;
if ( $retry > 0 ) {
$err .= " Problem with sql > " . htmlspecialchars( $sql ) . ".";
sleep(2);
try_logging_in( );
sleep(2);
$result=mysql_query(
"check table db_Object, db_Param, db_Log,
db_ValidValues, db_ValidParam , db_EntityType,
db_DataOut quick" ) or $err .= " Issue with $sql.";
sleep(1);
$result=mysql_query($sql);
}
return $result;
}
function get_param( $param ) {
if ( isset( $_POST["$param"] ) ) {
$tmp = $_POST["$param"];
$tmp = ereg_replace( '[;\|]', '', $tmp );
} else {
if ( isset( $_GET["$param"] ) ) {
$tmp = $_GET["$param"];
$tmp = ereg_replace( '[;"\|]', '', $tmp );
} else {
$tmp = null;
}
}
return( $tmp );
}
function peek_next_word( ) {
GLOBAL $program;
$orig_program = $program;
$word = get_next_word_upper();
$program = $orig_program;
return $word;
}
function get_next_word_upper( ) {
$word = get_next_word();
$word = strtoupper( $word );
return $word;
}
function get_next_word( ) {
GLOBAL $program;
$word = "";
$program = trim( $program );
if ( ereg( "^,", $program ) ) {
ereg( "^(,)(.*)$",$program, $tmp );
} else if ( ereg( "^'", $program ) ) {
ereg( "^'([^']+)'(.*)$",$program, $tmp );
} else if ( ereg( '^"', $program ) ) {
ereg( '^"([^"]+)"(.*)$',$program, $tmp );
} else {
ereg( "^([A-Za-z0-9\_'.%]+)(.*)$",$program, $tmp );
}
$word = $tmp[1];
if ( $word > '' ) {
$program = $tmp[2];
} else {
ereg( "^([^A-Za-z0-9]+ *)([A-Za-z0-9]*.*)$",$program, $tmp );
$word = $tmp[1];
$program = $tmp[2];
}
return( trim( $word ) );
}
function get_fields( $tabs ) {
return get_group_words( $tabs, 'fields' );
}
function get_tables( ) {
return get_group_words( array(), 'tables' );
}
function get_tables_and_fields( ) {
GLOBAL $program;
GLOBAL $cv;
$word = get_next_word();
if ( ereg( '^[A-Za-z09_]+[.][A-Za-z09_]+$', $word ) ) {
$word = array( ereg_replace( '[.]', ' ', $word ) );
}
$program = "$word $program";
$tabs = get_tables( );
$matches = get_fields( $tabs );
if ( count( $tabs ) == 0 ) { 
$err .= " Unknown tables $word.";
}
if ( count( $tabs ) == 0 ) { 
$err .= " Unknown fields for tables (" . implode( ',',$tabs ) . ").";
}
return $matches;
}
function get_group_words( $tabs, $type ) {
GLOBAL $program;
GLOBAL $cv;
GLOBAL $err;
$tmp = array();
$res = array();
$str = "";
$word = "";
do {
$str .= $word;
$word = get_next_word( );
$str .= $word;
if ( $word == '(' or $word == ')' ) { $word = get_next_word( ); }
if ( $word == "ALL" ) { $word = "'%'"; }
$tmp[] = $word;
$word = get_next_word( );
if ( $word == '(' or $word == ')' ) { $word = get_next_word( ); }
} while( $word == "," );
$program = "$word $program";
if ( $type == "values" ) {
return $tmp;
} else if ( $type == "fields" ) {
$sql = "select	concat( t.table_name, ':', s.column_name )
from    information_schema.TABLES t,
information_schema.COLUMNS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and t.table_name in ( '" .  implode( "','" , $tabs ) . "')
and s.table_name = t.table_name 
and s.table_schema = schema()
and ( 0 = 1";
foreach( $tmp as $field ) {
$sql .= " or s.column_name like '" . remove_quotes( $field ) . "'";
}
$sql .= ")";
$sql .= $cv['VAR:tables_sql'];
} else {
$sql = "select	t.table_name
from    information_schema.TABLES t
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and (  0 = 1";
foreach( $tmp as $field ) {
$sql .= " or t.table_name like '" . remove_quotes( $field ) . "'";
}
$sql .= ")";
$sql .= $cv['VAR:tables_sql'];
}
$result = run_sql( $sql );
while( list( $val ) = mysql_fetch_row($result) ) {
$res[] = $val;
}
if ( count( $res ) == 0 ) {
$err .= " Cannot find $type matching $str.";
}
return $res;
}	
function quoted( $tmp_str ) {
return( "'" . ereg_replace( "'", "", $tmp_str ) . "'" );
}
function remove_quotes( $tmp_str ) {
return( ereg_replace( "'", "", $tmp_str ) );
}
function get_field_name( $field ) {
GLOBAL $cv;
if ( isset( $cv[ "RENAME_COL:$field" ] ) ) {
return $cv[ "RENAME_COL:$field" ];
} else {
foreach( array_keys( $cv ) as $key ) {
if ( ereg( '^PK:',$key ) and $cv[$key] == $field ) {
$tmp = split( ':',$key );
$tab = $tmp[1];
if ( isset( $cv[ "RENAME_TAB:$tab" ] ) ) {
return $cv[ "RENAME_TAB:$tab" ];
} else {
return $tab;
}
}
}
return $field;
}
}
function get_table_name( $tab,$remove_quotes ) {
GLOBAL $cv;
$desc = $cv[ "RENAME_TAB:$tab" ];	
if ( $desc == "" ) { $desc = $tab; }
if ( $remove_quotes ) {
return( remove_quotes( $desc ) );
} else {
return( $desc );
}
}
function compile_program( ) {
GLOBAL $cv;
GLOBAL $program;
GLOBAL $submit;
GLOBAL $log_dir;
GLOBAL $logged_in;
GLOBAL $lookup;
GLOBAL $err;
$program = file_get_contents( "$log_dir/program" );
$str = $program;
$program .= "\n";
$program = ereg_replace( "#[^\n]*\n", '', $program );
while( $word = get_next_word_upper() ) {
if ( $word == "SET" ) {
$var = get_next_word();
if ( in_array( $var, $lookup["VARIABLES"] ) ) {
if ( $var == 'tables' ) {
$tabs = get_tables( );
if ( count( $tabs ) == 0 ) { 
$err .= " No matching tables."; 
} else {
$cv['VAR:tables_sql'] = " and t.table_name in ('" . 
implode( "','", $tabs ) . "')";
}
} else {
$val = get_next_word();
if ( ( ereg( 'max_', $var ) or ereg( '_size', $var ) )
and ! ereg( '[0-9]+', $val ) ) {
$err .= " Variable $var must hold a number.";
} else {
if ( $var == "img_bg" ) {
$val = lookup_preset( "BACKGROUNDS", $val );
}
$cv[ "VAR:$var" ] = $val;
}
}
} else {
$err .= " Unknown variable $var. Valid xv are (" . 
implode(',',$lookup["VARIABLES"]) . ").";
}
} else if ( $word == "ACCESS" ) {
$word = get_next_word_upper();
if ( $word == 'PUBLIC' ) { 
$word = $word;
} else if ( $word == 'REGISTERED' ) { 
$err .= " Only public access is currently supported."; 
} else {
$err .= " Unknown word $word in ACCESS command.";
}
} else if ( $word == "LOGIN" ) {
$cv[ 'VAR:dbu' ] = get_next_word();
$cv[ 'VAR:dbp' ] = get_next_word();
$cv[ 'VAR:dbd' ] = get_next_word();
$cv[ 'VAR:dbs' ] = get_next_word();
try_logging_in( );
} else if ( $word == "FIELD" ) {
$program = "ALL $program";
$tabs = get_tables( );
$matches = get_fields( $tabs );
if ( count( $matches ) == 0 ) {
$err .= " Cannot find field $field.";
}
do {
$orig_program = $program;
$word = get_next_word_upper();
if ( $word == "RENAME" ) {
$word = get_next_word();
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
$cv[ "RENAME_COL:$field" ] = $word;
}
} else if ( $word == "LOWERCASE" ) {
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
$cv[ "LOWER:$field" ] = "";
}
} else if ( $word == "UPPERCASE" ) {
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
$cv[ "UPPER:$field" ] = "";
}
} else if ( $word == "DEFAULT" ) {
$word = get_next_word();
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
$cv[ "DEFAULT:$field" ] = $word;
}
} else if ( $word == "VALUES" ) {
$tmp = get_group_words( array(), 'values' );
if ( count( $tmp ) == 1 ) {
$tmp = lookup_preset( "VALUES", $tmp[0] );
}
foreach( $matches as $match ) {
$tab = ereg_replace( ':.*','',$match );
$field = ereg_replace( '.*:','',$match );
$cv[ "FIELD_VALUES:$field" ] = implode( ',' , $tmp );
}
} else if ( $word == "BETWEEN" ) {
$from = get_next_word();
$word = get_next_word_upper();
$to = get_next_word();
if (	$word != "AND"
or ! ereg( $lookup["FORMAT"]["NUMBER"], $from )
or ! ereg( $lookup["FORMAT"]["NUMBER"], $to ) ) {
$err .= " Wrong format FIELD num_field BETWEEN number AND number.";
}
$cv[ "BETWEEN:$field" ] = "$from:$to";
} else if ( $word == "FORMAT" ) {
$word = get_next_word();
$word = lookup_preset( "FORMAT", $word );
if ( ! ereg( '^[^]', $word ) ) { $word = "^$word"; }
if ( ! ereg( '[$]$', $word ) ) { $word = "$word\$"; }
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
$cv[ "FORMAT:$field" ] = $word;
}
} else if ( $word == "LINK" ) {
$matches2 = get_tables_and_fields();
if ( count( $matches2 ) > 1 ) {
$err .= " Format wrong: FIELD field LINK table field.";
}
$tab2 = ereg_replace( ':.*', '', $matches2[0] );
$field2 = ereg_replace( '.*:', '', $matches2[0] );
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
if ( $tab != $tab2 or $field != $field2 ) {
$cv[ "LINK1:$tab:$field" ] = "$tab2:$field2";
$cv[ "LINK2:$tab2:$field2" ] = "$tab:$field";
}
}
} else {
$program = $orig_program;
break;
}
} while( 1 );
} else if ( $word == "REPORT" ) {
$name = get_next_word();
$pk = "";
do {
$orig_program = $program;
$word = get_next_word_upper();
if ( $word == "ON" ) {
$pk = get_next_word();
} else if ( $word == "START" ) {
$cv[ "START" ] = "REPORT:$name";
} else {
$program = $orig_program;
break;
}
} while( 1 );
$sql = get_next_word();
$cv[ "REPORT:$pk:$name" ] = $sql;
if ( sql_has_errors( $sql ) ) {
$err .= " SQL problem in report '$name'.";
}
} else if ( $word == "TABLE" ) {
$tabs = get_tables( );
do {
$word = get_next_word_upper();
if ( $word == "HIDE" ) {
$matches = get_fields( $tabs );
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
$cv[ "HIDE:$tab:$field" ] = '';
if ( $cv[ "MAIN_COL:$tab" ] == $field ) {
unset( $cv[ "MAIN_COL:$tab" ] );
}
}
} else if ( $word == "MAIN_COL" ) {
$matches = get_fields( $tabs );
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
if ( ! isset( $cv[ "HIDE:$tab:$field" ] ) ) {
$cv[ "MAIN_COL:$tab" ] = $field;
}
}
} else if ( $word == "RENAME" ) {
foreach( $tabs as $tab ) {
$cv[ "RENAME_TAB:$tab" ] = get_next_word();
}
if ( count( $tabs ) > 1 ) {
$err .= " RENAME working on more than one table.";
}
} else if ( $word == 'VERTICAL' ) {
foreach( $tabs as $tab ) {
$cv[ "VERTICAL:$tab" ] = "";
}
} else if ( $word == 'EDIT' ) {
$group = get_next_word_upper();
if ( ! in_array( $group, array( 'GUEST','SPECIAL','ADMIN' ) ) ) {
$err .= " EDIT must be followed by ADMIN | SPECIAL | GUEST.";
}
foreach( $tabs as $tab ) {
$cv[ "EDIT:$tab" ] = $group;
}
} else if ( $word == "START" ) {
foreach( $tabs as $tab ) {
$cv[ "START" ] = "TABLE:$tab";
}
if ( peek_next_word() == "PICK" ) {
$word = get_next_word();
$cv[ "PICK:$tab" ] = "";
}
} else if ( in_array( $word, array('SEARCH','URL') ) ) {
$matches = get_fields( $tabs );
foreach( $matches as $tmp ) {
$tab = ereg_replace( ':.*','',$tmp );
$field = ereg_replace( '.*:','',$tmp );
if ( ! isset( $cv[ "HIDE:$tab:$field" ] ) ) {
$cv[ "$word:$tab:$field" ] = '';
}
}
} else {
$program = "$word $program";
break;
}
} while( 1 );
} else if ( in_array( $word, array('HIDE','START','MAIN_COL','RENAME','SEARCH','URL' ) ) ) {
$err .= " $word command has appeared without giving table.";
} else {
$err .= " Unknow command $word.";
}
$sql = "select t.table_name 
from    information_schema.TABLES t
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE' " .
$cv['VAR:tables_sql'];
$result = run_sql( $sql );
while( list( $tab ) = mysql_fetch_row($result) ) {
if ( ! isset( $cv["PK:$tab"] ) ) {
$err .= " No primary key on $tab.";
}
}
}
return $str;
}
function build_compiled_file( ) {
GLOBAL $cv;
GLOBAL $log_dir;
try_logging_in( );
$sql_array = array(
"select   concat( 'PK:',s.table_name ), 
concat( 'concat(',group_concat( s.column_name ), ')' )
from    information_schema.TABLES t,
information_schema.STATISTICS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.index_name != 'PRIMARY'
and s.non_unique = 0
and s.table_schema = schema()
and s.table_name = t.table_name
and s.table_name not in (
select	s2.table_name
from    information_schema.STATISTICS s2
where   s2.index_name != 'PRIMARY'
and s2.non_unique = 0
and s2.table_schema = schema()
and s2.table_name = t.table_name
group by s2.table_name
having count(*) = 1 )",
"select  concat( 'PK:',s.table_name ), 
concat( 'concat(',group_concat( s.column_name ), ')' )
from    information_schema.TABLES t,
information_schema.STATISTICS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.index_name = 'PRIMARY'
and s.table_schema = schema()
and s.table_name = t.table_name
and s.table_name not in (
select	s2.table_name
from    information_schema.STATISTICS s2
where   s2.index_name = 'PRIMARY'
and s2.non_unique = 0
and s2.table_schema = schema()
and s2.table_name = t.table_name
group by s2.table_name
having count(*) = 1 )",
"select   concat( 'PK:',s.table_name ), s.column_name
from    information_schema.TABLES t,
information_schema.STATISTICS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.index_name != 'PRIMARY'
and s.non_unique = 0
and s.table_schema = schema()
and s.table_name = t.table_name
and s.table_name in (
select	s2.table_name
from    information_schema.STATISTICS s2
where   s2.index_name != 'PRIMARY'
and s2.non_unique = 0
and s2.table_schema = schema()
and s2.table_name = t.table_name
group by s2.table_name
having count(*) = 1 )",
"select  concat( 'PK:',s.table_name ), s.column_name
from    information_schema.TABLES t,
information_schema.STATISTICS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.index_name = 'PRIMARY'
and s.table_schema = schema()
and s.table_name = t.table_name
and s.table_name in (
select	s2.table_name
from    information_schema.STATISTICS s2
where   s2.index_name = 'PRIMARY'
and s2.non_unique = 0
and s2.table_schema = schema()
and s2.table_name = t.table_name
group by s2.table_name
having count(*) = 1 )",
"select concat( 'FK:',s.column_name), s2.table_name 
from    information_schema.TABLES t,
information_schema.STATISTICS s,
information_schema.TABLES t2,
information_schema.STATISTICS s2
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.index_name != 'PRIMARY'
and s.table_schema = schema()
and s.table_name = t.table_name
and s.non_unique = 1
and t2.table_schema = schema()
and t2.table_type = 'BASE TABLE'
and s2.index_name = 'PRIMARY'
and t2.table_name != t.table_name
and s2.table_schema = schema()
and s2.table_name = t2.table_name
and s2.column_name = s.column_name",
"select concat( 'MAIN_COL:',s.table_name ), s.column_name
from    information_schema.TABLES t,
information_schema.COLUMNS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.table_name = t.table_name 
and s.table_schema = schema()
and s.data_type in ( 'varchar','char' )",
"select concat( 'MAIN_COL:',s.table_name ), s.column_name
from    information_schema.TABLES t,
information_schema.STATISTICS s,
information_schema.COLUMNS c
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.index_name = 'PRIMARY'
and s.table_schema = schema()
and s.table_name = t.table_name
and c.table_schema = schema()
and c.table_name = t.table_name
and c.data_type in ( 'varchar','char' )",
"select concat( 'FIELDS:',s.table_name, ':', s.column_name ), s.data_type
from    information_schema.TABLES t,
information_schema.COLUMNS s
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.table_name = t.table_name 
and s.table_schema = schema()",
"select 'START', concat( 'TABLE:',min(t.table_name) )
from    information_schema.TABLES t,
information_schema.STATISTICS s,
information_schema.COLUMNS c
where   t.table_schema = schema()
and t.table_type = 'BASE TABLE'
and s.index_name = 'PRIMARY'
and s.table_schema = schema()
and s.table_name = t.table_name
and c.table_schema = schema()
and c.table_name = t.table_name
and c.data_type in ( 'varchar','char' )"
);
foreach( $sql_array as $sql ) {
$sql .= $cv['VAR:tables_sql'];
if ( ereg( 'group_concat', $sql ) ) {
$sql .= ' group by s.table_name';
}
$result = run_sql( $sql );
while( list( $key,$val ) = mysql_fetch_row($result) ) {
$cv[$key] = $val;
if ( ereg( '^PK:', $key ) ) {
$pk = $val;
$tab = ereg_replace( '.*:', '', $key );
if ( ! isset( $cv[ "FK:$pk" ] ) ) {
$cv[ "FK:$pk" ] = $tab;
}
}
}
}
$program = compile_program( );
$done = array();
foreach( array_keys( $cv ) as $key ) {
if ( ereg( '^PK:',$key ) ) {
$tmp = split( ':',$key );
$tab = $tmp[1];
$field = $cv[ "MAIN_COL:$tab" ];
$tmp = show_field_for_sql( $tab, $field, 1 );
$cv[ "SQL_SHOW:$tab" ] .= $tmp;
$done[] = "$tab:$field";
foreach( array_keys( $cv ) as $key2 ) {
if ( ereg( "^URL:$tab:",$key2 ) ) {
$tmp = split( ':',$key2 );
$field = $tmp[2];
$tmp = show_field_for_sql( $tab, $field, 1 );
if ( $tmp > "" and ! in_array( "$tab,$field", $done ) ) {
if ( $cv[ "SQL_SHOW:$tab" ] > "" ) { 
$cv[ "SQL_SHOW:$tab" ] .= ", "; 
}
$cv[ "SQL_SHOW:$tab" ] .= $tmp;
$done[] = "$tab:$field";
}
}
}
foreach( array_keys( $cv ) as $key2 ) {
if ( ereg( "^FIELDS:$tab:",$key2 ) ) {
$tmp = split( ':',$key2 );
$field = $tmp[2];
if ( isset( $cv[ "FK:$field" ] ) ) {
$fk_tab = $cv[ "FK:$field" ];
$tmp = show_field_for_sql( $tab, $field, 1 );
if (	$tmp > "" 
and $tab != $fk_tab
and ! in_array( "$tab,$field", $done ) ) {
if ( $cv[ "SQL_SHOW:$tab" ] > "" ) { 
$cv[ "SQL_SHOW:$tab" ] .= ", "; 
}
$cv[ "SQL_SHOW:$tab" ] .= $tmp;
$done[] = "$tab:$field";
}
}
}
}
}
}
foreach( array_keys( $cv ) as $key ) {
$tmp = split( ':',$key );
$tab = $tmp[1];
$field = $tmp[2];
if ( ereg( '^FIELDS:',$key ) ) {
$tmp = show_field_for_sql( $tab, $field, 1 );
if ( $tmp > "" and ! in_array( "$tab,$field", $done ) ) {
if ( $cv[ "SQL_SHOW:$tab" ] > "" ) { $cv[ "SQL_SHOW:$tab" ] .= ", "; }
$cv[ "SQL_SHOW:$tab" ] .= $tmp;
}
}
}
$sql = "";
$old_tab = "";
$cv[ "SQL_SEARCH" ] = "";
$tmp_array = array_keys( $cv );
sort( $tmp_array );
foreach( $tmp_array as $key ) {
if ( ereg( "^SEARCH:", $key ) ) {
$tmp = explode( ':', $key );
$tmp_tab = $tmp[1];
$tmp_field = $tmp[2];
if ( $tmp_tab != $old_tab ) {
$old_tab = $tmp_tab;
if ( $cv[ "SQL_SEARCH" ] > "" ) {
$cv[ "SQL_SEARCH" ] .= " union ";
}
$show_field = $cv[ "MAIN_COL:$tmp_tab" ];
$cv[ "SQL_SEARCH" ] .= " select " .
show_field_for_sql( $tmp_tab, $show_field, 1 ) .
" from $tmp_tab t where 1=0 "; 
}
$cv[ "SQL_SEARCH" ] .= " or $tmp_field like 'INPUT_STR'";
}
}
encrypt_var( 'encode' );
$fh = fopen( "$log_dir/compiled", "w" );
fwrite( $fh, serialize( $cv ) );
fclose( $fh );
encrypt_var( 'decode' );
return $program;
}
function encrypt_var( $direction ) {
GLOBAL $cv;
foreach( array_keys( $form ) as $key ) {
if ( ereg( '^VAR:', $key ) ) {
$var = ereg_replace( ".*:", "", $key );
if ( in_array( $var, $cv[ "ENCRYPT_VAR" ] ) ) {
if ( $direction == 'encode' ) {
$cv[ "VAR:$var" ] = base64_encode( $cv[ "VAR:$var" ] );
} else {
$cv[ "VAR:$var" ] = base64_decode( $cv[ "VAR:$var" ] );
}
}
}
}
}
function try_logging_in( ) {
GLOBAL $cv;
GLOBAL $logged_in;
$logged_in=0;
mysql_pconnect($cv['VAR:dbs'],$cv['VAR:dbu'],$cv['VAR:dbp'])
or $logged_in = -1;
if ( $logged_in == 0 ) {
$sql = "select database()";
$result = run_sql( $sql );
list( $name ) = mysql_fetch_row($result);
if ( $name != $cv['VAR:dbd'] ) {
mysql_select_db($cv['VAR:dbd']) or $logged_in = -2;
}
}
if ( $logged_in == 0 ) { 
$logged_in = 1; 
}
}
function treat_inp_str( $str ) {
$str = trim( $str );
$str = ereg_replace( "'", "\\'", $str );
$str = ereg_replace( '"', '\\"', $str );
if ( ereg( '[^0-9]', $str ) or ereg( '^0[0-9]', $str ) ) {
$str = "'$str'"; 
}
return $str;
}
function get_name_of( $pk, $id ) {
GLOBAL $cv;
GLOBAL $prog;
$tab = $cv[ "FK:$pk" ];
foreach( array_keys( $cv ) as $key ) {
if (	ereg( '^PK:', $key ) and $cv[$key] == $pk 
or $key == "FK:$pk" ) {
if ( $key == "FK:$pk" ) {
$tab = $cv[$key];
} else {
$tab = ereg_replace( '.*:', '', $key );
}
$show_field = $cv[ "MAIN_COL:$tab" ];
$sql =	"select max($show_field) " .
"from $tab t where $pk = " . treat_inp_str( $id );
$result = run_sql( $sql );
list( $name ) = mysql_fetch_row($result);
if ( ereg( '[A-Za-z]', $name ) ) { break; }
}
}
$url = "<a href=${prog}?tab=$tab&pk=$pk&a=15&id=" . urlencode( $id ) . ">$name</a>";
return( $url );
}
function fix_spaces_in_url( $data ) {
if ( ereg( '&id=',$data ) ) { 
$tmp = split( '&id=', $data );
$tmp[1] = urlencode( ereg_replace( '>.*','', $tmp[1] ) ) .
ereg_replace( '^[^>]*','', $tmp[1] );
$data = implode( '&id=',$tmp );
}
return $data;
}
function print_data_item( $submit, $tab, $key, $data, $cnt, $pk, $id, $print_td_flg ) {
GLOBAL $cv;
GLOBAL $mobile_flg;
GLOBAL $in_limit;
GLOBAL $prog;
GLOBAL $lookup;
GLOBAL $target;
$data = fix_spaces_in_url( $data );
if ( $tab == "" ) {
foreach( array_keys( $cv ) as $k ) {
if ( ereg( "URL:.*:$key", $k ) ) {
$tmp = split( ':', $k );
$tab = $tmp[1];
}
}
}
if ( $submit == "Report" and $cv[ "FK:$key" ] > "" ) {
$tab = $cv[ "FK:$key" ];
$data = "<a href=${prog}?tab=$tab&pk=$key&a=16&id=". urlencode($data) .">$data</a>";
} else if ( isset( $cv[ "URL:$tab:$key" ] ) ) {
$url = $data;
if ( ! ereg( 'http',$url ) and ! ereg( 'www',$url ) and $cv['VAR:url_base_dir'] > "" ) { 
$url = $cv['VAR:url_base_dir'] . "/$url";
}
if ( ! ereg( 'http',$url ) ) { 
$url = "http://$url";
}
$postfix = strtolower( ereg_replace( '.*\.', '', $data ) );
if ( in_array( $postfix, $lookup["IMAGE_POSTFIXES"] ) ) {
if ( $mobile_flg and $in_limit != -2 ) {
$data = "<a href=${prog}?tab=$tab&pk=$pk&limit=-2&a=21&id=". urlencode($id) .
">view image</a>";
} else if ( $cnt != 1 ) {
$data = "<a href=$url $target><img width=" .
$cv['VAR:img_x_size_small'] .
" height=" .
$cv['VAR:img_y_size_small'] .
" src=$url></a>";
} else {
$data = "<a href=$url $target><img width=" .
$cv['VAR:img_x_size'] .
" height=" .
$cv['VAR:img_y_size'] .
" src=$url></a>";
}
} else if ( in_array( $postfix, $lookup[ "AUDIO_POSTFIXES" ] ) ) {
$data = "<a href=$url>play audio</a>";
} else if ( in_array( $postfix, $lookup[ "VIDEO_POSTFIXES" ] ) ) {
$data = "<a href=$url>play video</a>";
} else if ( ereg( $lookup["FORMAT"]["EMAIL"], $data ) ) {
$data = "<a href='mailto:$data'>$data</a>";
} else {
if ( strlen( $data ) > 35 ) {
$data = "<a href=$url $target>..." . substr( $data,-30 ) . "</a>";
} else {
$data = "<a href=$url $target>$data</a>";
}
}
} else if ( $submit == "Report" and $cv[ "LINK1:.*:$key" ] > "" ) {
$tab = ereg_replace( ':.*', '', 
$cv[ "LINK1:$tab:$key" ] );
$field = ereg_replace( '.*:', '', 
$cv[ "LINK1:$tab:$key" ] );
$data = "<a href=${prog}?tab=$tab&pk=$field&a=17&id=$data>$data</a>";
} else if ( count( fk_details( $tab, $key ) ) > 0 ) {
$fk_details = fk_details( $tab, $key ); 
$fk_tab = $fk_details["tab"];
$tmp_pk = $cv[ "PK:$fk_tab" ];
$data = "<a href=${prog}?fk_tab=$tab&pk=$tmp_pk&a=23&id=$id>$data</a>";
}
if ( $print_td_flg and ereg( $lookup["FORMAT"]["NUMBER"], $data ) ) {
$data = "<td align=right>$data</td>";
} else if ( $print_td_flg ) {
if ( $data == "" ) { 
$data = "<td align=center>-</td>";
} else {
$data = "<td>$data</td>";
}
}
return $data;
}
function mobile_device_detect( ) {
$iphone=true;
$android=true;
$opera=true;
$blackberry=true;
$palm=true;
$windows=true;
$mobileredirect=false;
$desktopredirect=false;
$mobile_browser   = false; 
$user_agent       = $_SERVER['HTTP_USER_AGENT']; 
$accept           = $_SERVER['HTTP_ACCEPT']; 
switch(true){ 
case (eregi('ipod',$user_agent)||eregi('iphone',$user_agent)); 
$mobile_browser = $iphone; 
if(substr($iphone,0,4)=='http'){ 
} 
break; 
case (eregi('android',$user_agent));  
$mobile_browser = $android; 
if(substr($android,0,4)=='http'){ 
} 
break; 
case (eregi('opera mini',$user_agent)); 
$mobile_browser = $opera; 
if(substr($opera,0,4)=='http'){ 
} 
break; 
case (eregi('blackberry',$user_agent)); 
$mobile_browser = $blackberry; 
if(substr($blackberry,0,4)=='http'){ 
} 
break; 
case (preg_match('/(palm os|palm|hiptop|avantgo|plucker|xiino|blazer|elaine)/i',$user_agent)); 
$mobile_browser = $palm; 
if(substr($palm,0,4)=='http'){ 
} 
break; 
case (preg_match('/(windows ce; ppc;|windows ce; smartphone;|windows ce; iemobile)/i',$user_agent)); 
$mobile_browser = $windows; 
if(substr($windows,0,4)=='http'){ 
} 
break; 
case (preg_match('/(up.browser|up.link|mmp|symbian|smartphone|midp|wap|vodafone|o2|pocket|kindle|mobile|pda|psp|treo)/i',$user_agent)); 
$mobile_browser = true; 
break; 
case ((strpos($accept,'text/vnd.wap.wml')>0)||(strpos($accept,'application/vnd.wap.xhtml+xml')>0)); 
$mobile_browser = true; 
break; 
case (isset($_SERVER['HTTP_X_WAP_PROFILE'])||isset($_SERVER['HTTP_PROFILE'])); 
$mobile_browser = true; 
break; 
case (in_array(strtolower(substr($user_agent,0,4)),array('1207'=>'1207','3gso'=>'3gso','4thp'=>'4thp',
'501i'=>'501i','502i'=>'502i','503i'=>'503i','504i'=>'504i','505i'=>'505i','506i'=>'506i','6310'=>'6310',
'6590'=>'6590','770s'=>'770s','802s'=>'802s','a wa'=>'a wa','acer'=>'acer','acs-'=>'acs-','airn'=>'airn',
'alav'=>'alav','asus'=>'asus','attw'=>'attw','au-m'=>'au-m','aur '=>'aur ','aus '=>'aus ','abac'=>'abac',
'acoo'=>'acoo','aiko'=>'aiko','alco'=>'alco','alca'=>'alca','amoi'=>'amoi','anex'=>'anex','anny'=>'anny',
'anyw'=>'anyw','aptu'=>'aptu','arch'=>'arch','argo'=>'argo','bell'=>'bell','bird'=>'bird','bw-n'=>'bw-n',
'bw-u'=>'bw-u','beck'=>'beck','benq'=>'benq','bilb'=>'bilb','blac'=>'blac','c55/'=>'c55/','cdm-'=>'cdm-',
'chtm'=>'chtm','capi'=>'capi','comp'=>'comp','cond'=>'cond','craw'=>'craw','dall'=>'dall','dbte'=>'dbte',
'dc-s'=>'dc-s','dica'=>'dica','ds-d'=>'ds-d','ds12'=>'ds12','dait'=>'dait','devi'=>'devi','dmob'=>'dmob',
'doco'=>'doco','dopo'=>'dopo','el49'=>'el49','erk0'=>'erk0','esl8'=>'esl8','ez40'=>'ez40','ez60'=>'ez60',
'ez70'=>'ez70','ezos'=>'ezos','ezze'=>'ezze','elai'=>'elai','emul'=>'emul','eric'=>'eric','ezwa'=>'ezwa',
'fake'=>'fake','fly-'=>'fly-','fly_'=>'fly_','g-mo'=>'g-mo','g1 u'=>'g1 u','g560'=>'g560','gf-5'=>'gf-5',
'grun'=>'grun','gene'=>'gene','go.w'=>'go.w','good'=>'good','grad'=>'grad','hcit'=>'hcit','hd-m'=>'hd-m',
'hd-p'=>'hd-p','hd-t'=>'hd-t','hei-'=>'hei-','hp i'=>'hp i','hpip'=>'hpip','hs-c'=>'hs-c','htc '=>'htc ',
'htc-'=>'htc-','htca'=>'htca','htcg'=>'htcg','htcp'=>'htcp','htcs'=>'htcs','htct'=>'htct','htc_'=>'htc_',
'haie'=>'haie','hita'=>'hita','huaw'=>'huaw','hutc'=>'hutc','i-20'=>'i-20','i-go'=>'i-go','i-ma'=>'i-ma',
'i230'=>'i230','iac'=>'iac','iac-'=>'iac-','iac/'=>'iac/','ig01'=>'ig01','im1k'=>'im1k','inno'=>'inno',
'iris'=>'iris','jata'=>'jata','java'=>'java','kddi'=>'kddi','kgt'=>'kgt','kgt/'=>'kgt/','kpt '=>'kpt ',
'kwc-'=>'kwc-','klon'=>'klon','lexi'=>'lexi','lg g'=>'lg g','lg-a'=>'lg-a','lg-b'=>'lg-b','lg-c'=>'lg-c',
'lg-d'=>'lg-d','lg-f'=>'lg-f','lg-g'=>'lg-g','lg-k'=>'lg-k','lg-l'=>'lg-l','lg-m'=>'lg-m','lg-o'=>'lg-o',
'lg-p'=>'lg-p','lg-s'=>'lg-s','lg-t'=>'lg-t','lg-u'=>'lg-u','lg-w'=>'lg-w','lg/k'=>'lg/k','lg/l'=>'lg/l',
'lg/u'=>'lg/u','lg50'=>'lg50','lg54'=>'lg54','lge-'=>'lge-','lge/'=>'lge/','lynx'=>'lynx','leno'=>'leno',
'm1-w'=>'m1-w','m3ga'=>'m3ga','m50/'=>'m50/','maui'=>'maui','mc01'=>'mc01','mc21'=>'mc21','mcca'=>'mcca',
'medi'=>'medi','meri'=>'meri','mio8'=>'mio8','mioa'=>'mioa','mo01'=>'mo01','mo02'=>'mo02','mode'=>'mode',
'modo'=>'modo','mot '=>'mot ','mot-'=>'mot-','mt50'=>'mt50','mtp1'=>'mtp1','mtv '=>'mtv ','mate'=>'mate',
'maxo'=>'maxo','merc'=>'merc','mits'=>'mits','mobi'=>'mobi','motv'=>'motv','mozz'=>'mozz','n100'=>'n100',
'n101'=>'n101','n102'=>'n102','n202'=>'n202','n203'=>'n203','n300'=>'n300','n302'=>'n302','n500'=>'n500',
'n502'=>'n502','n505'=>'n505','n700'=>'n700','n701'=>'n701','n710'=>'n710','nec-'=>'nec-','nem-'=>'nem-',
'newg'=>'newg','neon'=>'neon','netf'=>'netf','noki'=>'noki','nzph'=>'nzph','o2 x'=>'o2 x','o2-x'=>'o2-x',
'opwv'=>'opwv','owg1'=>'owg1','opti'=>'opti','oran'=>'oran','p800'=>'p800','pand'=>'pand','pg-1'=>'pg-1',
'pg-2'=>'pg-2','pg-3'=>'pg-3','pg-6'=>'pg-6','pg-8'=>'pg-8','pg-c'=>'pg-c','pg13'=>'pg13','phil'=>'phil',
'pn-2'=>'pn-2','pt-g'=>'pt-g','palm'=>'palm','pana'=>'pana','pire'=>'pire','pock'=>'pock','pose'=>'pose',
'psio'=>'psio','qa-a'=>'qa-a','qc-2'=>'qc-2','qc-3'=>'qc-3','qc-5'=>'qc-5','qc-7'=>'qc-7','qc07'=>'qc07',
'qc12'=>'qc12','qc21'=>'qc21','qc32'=>'qc32','qc60'=>'qc60','qci-'=>'qci-','qwap'=>'qwap','qtek'=>'qtek',
'r380'=>'r380','r600'=>'r600','raks'=>'raks','rim9'=>'rim9','rove'=>'rove','s55/'=>'s55/','sage'=>'sage',
'sams'=>'sams','sc01'=>'sc01','sch-'=>'sch-','scp-'=>'scp-','sdk/'=>'sdk/','se47'=>'se47','sec-'=>'sec-',
'sec0'=>'sec0','sec1'=>'sec1','semc'=>'semc','sgh-'=>'sgh-','shar'=>'shar','sie-'=>'sie-','sk-0'=>'sk-0',
'sl45'=>'sl45','slid'=>'slid','smb3'=>'smb3','smt5'=>'smt5','sp01'=>'sp01','sph-'=>'sph-','spv '=>'spv ',
'spv-'=>'spv-','sy01'=>'sy01','samm'=>'samm','sany'=>'sany','sava'=>'sava','scoo'=>'scoo','send'=>'send',
'siem'=>'siem','smar'=>'smar','smit'=>'smit','soft'=>'soft','sony'=>'sony','t-mo'=>'t-mo','t218'=>'t218',
't250'=>'t250','t600'=>'t600','t610'=>'t610','t618'=>'t618','tcl-'=>'tcl-','tdg-'=>'tdg-','telm'=>'telm',
'tim-'=>'tim-','ts70'=>'ts70','tsm-'=>'tsm-','tsm3'=>'tsm3','tsm5'=>'tsm5','tx-9'=>'tx-9','tagt'=>'tagt',
'talk'=>'talk','teli'=>'teli','topl'=>'topl','tosh'=>'tosh','up.b'=>'up.b','upg1'=>'upg1','utst'=>'utst',
'v400'=>'v400','v750'=>'v750','veri'=>'veri','vk-v'=>'vk-v','vk40'=>'vk40','vk50'=>'vk50','vk52'=>'vk52',
'vk53'=>'vk53','vm40'=>'vm40','vx98'=>'vx98','virg'=>'virg','vite'=>'vite','voda'=>'voda','vulc'=>'vulc',
'w3c '=>'w3c ','w3c-'=>'w3c-','wapj'=>'wapj','wapp'=>'wapp','wapu'=>'wapu','wapm'=>'wapm','wig '=>'wig ',
'wapi'=>'wapi','wapr'=>'wapr','wapv'=>'wapv','wapy'=>'wapy','wapa'=>'wapa','waps'=>'waps','wapt'=>'wapt',
'winc'=>'winc','winw'=>'winw','wonu'=>'wonu','x700'=>'x700','xda2'=>'xda2','xdag'=>'xdag','yas-'=>'yas-',
'your'=>'your','zte-'=>'zte-','zeto'=>'zeto','acs-'=>'acs-','alav'=>'alav','alca'=>'alca','amoi'=>'amoi',
'aste'=>'aste','audi'=>'audi','avan'=>'avan','benq'=>'benq','bird'=>'bird','blac'=>'blac','blaz'=>'blaz',
'brew'=>'brew','brvw'=>'brvw','bumb'=>'bumb','ccwa'=>'ccwa','cell'=>'cell','cldc'=>'cldc','cmd-'=>'cmd-',
'dang'=>'dang','doco'=>'doco','eml2'=>'eml2','eric'=>'eric','fetc'=>'fetc','hipt'=>'hipt','http'=>'http',
'ibro'=>'ibro','idea'=>'idea','ikom'=>'ikom','inno'=>'inno','ipaq'=>'ipaq','jbro'=>'jbro','jemu'=>'jemu',
'java'=>'java','jigs'=>'jigs','kddi'=>'kddi','keji'=>'keji','kyoc'=>'kyoc','kyok'=>'kyok','leno'=>'leno',
'lg-c'=>'lg-c','lg-d'=>'lg-d','lg-g'=>'lg-g','lge-'=>'lge-','libw'=>'libw','m-cr'=>'m-cr','maui'=>'maui',
'maxo'=>'maxo','midp'=>'midp','mits'=>'mits','mmef'=>'mmef','mobi'=>'mobi','mot-'=>'mot-','moto'=>'moto',
'mwbp'=>'mwbp','mywa'=>'mywa','nec-'=>'nec-','newt'=>'newt','nok6'=>'nok6','noki'=>'noki','o2im'=>'o2im',
'opwv'=>'opwv','palm'=>'palm','pana'=>'pana','pant'=>'pant','pdxg'=>'pdxg','phil'=>'phil','play'=>'play',
'pluc'=>'pluc','port'=>'port','prox'=>'prox','qtek'=>'qtek','qwap'=>'qwap','rozo'=>'rozo','sage'=>'sage',
'sama'=>'sama','sams'=>'sams','sany'=>'sany','sch-'=>'sch-','sec-'=>'sec-','send'=>'send','seri'=>'seri',
'sgh-'=>'sgh-','shar'=>'shar','sie-'=>'sie-','siem'=>'siem','smal'=>'smal','smar'=>'smar','sony'=>'sony',
'sph-'=>'sph-','symb'=>'symb','t-mo'=>'t-mo','teli'=>'teli','tim-'=>'tim-','tosh'=>'tosh','treo'=>'treo',
'tsm-'=>'tsm-','upg1'=>'upg1','upsi'=>'upsi','vk-v'=>'vk-v','voda'=>'voda','vx52'=>'vx52','vx53'=>'vx53',
'vx60'=>'vx60','vx61'=>'vx61','vx70'=>'vx70','vx80'=>'vx80','vx81'=>'vx81','vx83'=>'vx83','vx85'=>'vx85',
'wap-'=>'wap-','wapa'=>'wapa','wapi'=>'wapi','wapp'=>'wapp','wapr'=>'wapr','webc'=>'webc','whit'=>'whit',
'winw'=>'winw','wmlb'=>'wmlb','xda-'=>'xda-',))); 
$mobile_browser = true; 
break; 
} 
return $mobile_browser; 
} 
function testing( $str ) {
if ( 1 == 1 ) { print( $str ); }
}
?>
